/* PulseAudioManager.c generated by valac 0.42.2, the Vala compiler
 * generated from PulseAudioManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/*
 * Vocabulary of PulseAudio:
 *  - Source: Input (microphone)
 *  - Sink: Output (speaker)
 */


#include <glib.h>
#include <glib-object.h>
#include <pulse/pulseaudio.h>
#include <pulse/glib-mainloop.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "pulse/ext-stream-restore.h"
#include <float.h>
#include <math.h>


#define SOUND_TYPE_PULSE_AUDIO_MANAGER (sound_pulse_audio_manager_get_type ())
#define SOUND_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager))
#define SOUND_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))
#define SOUND_IS_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_IS_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_PULSE_AUDIO_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))

typedef struct _SoundPulseAudioManager SoundPulseAudioManager;
typedef struct _SoundPulseAudioManagerClass SoundPulseAudioManagerClass;
typedef struct _SoundPulseAudioManagerPrivate SoundPulseAudioManagerPrivate;

#define SOUND_TYPE_DEVICE (sound_device_get_type ())
#define SOUND_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_DEVICE, SoundDevice))
#define SOUND_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_DEVICE, SoundDeviceClass))
#define SOUND_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_DEVICE))
#define SOUND_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_DEVICE))
#define SOUND_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_DEVICE, SoundDeviceClass))

typedef struct _SoundDevice SoundDevice;
typedef struct _SoundDeviceClass SoundDeviceClass;
enum  {
	SOUND_PULSE_AUDIO_MANAGER_0_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES
};
static GParamSpec* sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES];
#define _pa_context_unref0(var) ((var == NULL) ? NULL : (var = (pa_context_unref (var), NULL)))
#define _pa_glib_mainloop_free0(var) ((var == NULL) ? NULL : (var = (pa_glib_mainloop_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _pa_operation_unref0(var) ((var == NULL) ? NULL : (var = (pa_operation_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _SoundDevicePrivate SoundDevicePrivate;
#define _pa_proplist_free0(var) ((var == NULL) ? NULL : (var = (pa_proplist_free (var), NULL)))
typedef struct _SoundPulseAudioManagerReconnectToPulseData SoundPulseAudioManagerReconnectToPulseData;
typedef struct _Block2Data Block2Data;

#define SOUND_DEVICE_TYPE_PORT (sound_device_port_get_type ())
#define SOUND_DEVICE_PORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_DEVICE_TYPE_PORT, SoundDevicePort))
#define SOUND_DEVICE_PORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_DEVICE_TYPE_PORT, SoundDevicePortClass))
#define SOUND_DEVICE_IS_PORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_DEVICE_TYPE_PORT))
#define SOUND_DEVICE_IS_PORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_DEVICE_TYPE_PORT))
#define SOUND_DEVICE_PORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_DEVICE_TYPE_PORT, SoundDevicePortClass))

typedef struct _SoundDevicePort SoundDevicePort;
typedef struct _SoundDevicePortClass SoundDevicePortClass;
typedef struct _SoundDevicePortPrivate SoundDevicePortPrivate;
#define _sound_device_port_unref0(var) ((var == NULL) ? NULL : (var = (sound_device_port_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
enum  {
	SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL,
	SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS
};
static guint sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS] = {0};

struct _SoundPulseAudioManager {
	GObject parent_instance;
	SoundPulseAudioManagerPrivate * priv;
};

struct _SoundPulseAudioManagerClass {
	GObjectClass parent_class;
};

struct _SoundPulseAudioManagerPrivate {
	pa_context* _context;
	pa_glib_mainloop* loop;
	gboolean is_ready;
	guint reconnect_timer_id;
	GeeHashMap* input_devices;
	GeeHashMap* output_devices;
	SoundDevice* _default_output;
	SoundDevice* _default_input;
	gchar* default_source_name;
	gchar* default_sink_name;
	GeeHashMap* volume_operations;
};

struct _Block1Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};

struct _SoundDevice {
	GObject parent_instance;
	SoundDevicePrivate * priv;
	GeeLinkedList* volume_operations;
};

struct _SoundDeviceClass {
	GObjectClass parent_class;
};

struct _SoundPulseAudioManagerReconnectToPulseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	SoundPulseAudioManager* self;
	gboolean _tmp0_;
	pa_context* _tmp1_;
	pa_proplist* props;
	pa_proplist* _tmp2_;
	pa_proplist* _tmp3_;
	pa_glib_mainloop* _tmp4_;
	pa_mainloop_api* _tmp5_;
	pa_proplist* _tmp6_;
	pa_context* _tmp7_;
	pa_context* _tmp8_;
	pa_context* _tmp9_;
	pa_context* _tmp10_;
	pa_context* _tmp11_;
	const gchar* _tmp12_;
};

struct _Block2Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};

struct _SoundDevicePort {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SoundDevicePortPrivate * priv;
	gchar* name;
	gchar* description;
	guint32 priority;
};

struct _SoundDevicePortClass {
	GTypeClass parent_class;
	void (*finalize) (SoundDevicePort *self);
};

struct _Block3Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};


static gint SoundPulseAudioManager_private_offset;
static gpointer sound_pulse_audio_manager_parent_class = NULL;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam = NULL;

GType sound_pulse_audio_manager_get_type (void) G_GNUC_CONST;
GType sound_device_get_type (void) G_GNUC_CONST;
SoundPulseAudioManager* sound_pulse_audio_manager_get_default (void);
static SoundPulseAudioManager* sound_pulse_audio_manager_new (void);
static SoundPulseAudioManager* sound_pulse_audio_manager_construct (GType object_type);
void sound_pulse_audio_manager_start (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_);
void sound_pulse_audio_manager_set_default_device (SoundPulseAudioManager* self,
                                                   SoundDevice* device);
gboolean sound_device_get_input (SoundDevice* self);
const gchar* sound_device_get_name (SoundDevice* self);
pa_context* sound_pulse_audio_manager_get_context (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self,
                                                                        pa_context* c,
                                                                        pa_ext_stream_restore_info* info,
                                                                        gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                                pa_ext_stream_restore_info* info,
                                                                                                                gint eol,
                                                                                                                gpointer self);
static void sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self,
                                                                      pa_context* c,
                                                                      pa_ext_stream_restore_info* info,
                                                                      gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                              pa_ext_stream_restore_info* info,
                                                                                                              gint eol,
                                                                                                              gpointer self);
void sound_pulse_audio_manager_change_device_mute (SoundPulseAudioManager* self,
                                                   SoundDevice* device,
                                                   gboolean mute);
guint32 sound_device_get_index (SoundDevice* self);
void sound_pulse_audio_manager_change_device_volume (SoundPulseAudioManager* self,
                                                     SoundDevice* device,
                                                     gdouble volume);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block1Data* _data1_,
                     pa_operation* operation);
static gboolean ___lambda7__gee_forall_func (gpointer g,
                                      gpointer self);
void sound_device_get_cvolume (SoundDevice* self,
                               pa_cvolume * result);
static pa_volume_t sound_pulse_audio_manager_double_to_volume (gdouble vol);
void sound_pulse_audio_manager_change_device_balance (SoundPulseAudioManager* self,
                                                      SoundDevice* device,
                                                      gfloat balance);
void sound_device_get_channel_map (SoundDevice* self,
                                   pa_channel_map * result);
static gboolean sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data);
static void sound_pulse_audio_manager_reconnect_to_pulse_async_ready_wrapper (GObject *source_object,
                                                                       GAsyncResult *res,
                                                                       void *user_data);
static gboolean sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_);
static void sound_pulse_audio_manager_set_context (SoundPulseAudioManager* self,
                                            pa_context* value);
static void sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self,
                                                       pa_context* c);
static void _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                               gpointer self);
static void sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_subscription_event_type_t t,
                                                   guint32 index);
static void _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                              pa_subscription_event_type_t t,
                                                                              guint32 idx,
                                                                              gpointer self);
static void sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self,
                                                     pa_context* c,
                                                     pa_server_info* i);
static void _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                                          pa_server_info* i,
                                                                          gpointer self);
static gboolean _sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self);
static void sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_sink_info* i,
                                                   gint eol);
static void _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c,
                                                                      pa_sink_info* i,
                                                                      gint eol,
                                                                      gpointer self);
static void sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self,
                                                     pa_context* c,
                                                     pa_source_info* i,
                                                     gint eol);
static void _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c,
                                                                          pa_source_info* i,
                                                                          gint eol,
                                                                          gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
SoundDevice* sound_device_new (guint32 index);
SoundDevice* sound_device_construct (GType object_type,
                                     guint32 index);
void sound_device_set_input (SoundDevice* self,
                             gboolean value);
void sound_device_set_name (SoundDevice* self,
                            const gchar* value);
void sound_device_set_display_name (SoundDevice* self,
                                    const gchar* value);
void sound_device_set_is_muted (SoundDevice* self,
                                gboolean value);
void sound_device_set_cvolume (SoundDevice* self,
                               pa_cvolume * value);
void sound_device_set_channel_map (SoundDevice* self,
                                   pa_channel_map * value);
void sound_device_set_balance (SoundDevice* self,
                               gfloat value);
static gboolean __lambda6_ (Block2Data* _data2_,
                     pa_operation* operation);
static gboolean ___lambda6__gee_forall_func (gpointer g,
                                      gpointer self);
gpointer sound_device_port_ref (gpointer instance);
void sound_device_port_unref (gpointer instance);
GParamSpec* sound_device_param_spec_port (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void sound_device_value_set_port (GValue* value,
                                  gpointer v_object);
void sound_device_value_take_port (GValue* value,
                                   gpointer v_object);
gpointer sound_device_value_get_port (const GValue* value);
GType sound_device_port_get_type (void) G_GNUC_CONST;
GeeArrayList* sound_device_get_ports (SoundDevice* self);
void sound_device_set_default_port (SoundDevice* self,
                                    SoundDevicePort* value);
SoundDevicePort* sound_device_port_new (void);
SoundDevicePort* sound_device_port_construct (GType object_type);
static gdouble sound_pulse_audio_manager_volume_to_double (pa_volume_t vol);
void sound_device_set_volume (SoundDevice* self,
                              gdouble value);
void sound_device_set_form_factor (SoundDevice* self,
                                   const gchar* value);
void sound_device_set_is_default (SoundDevice* self,
                                  gboolean value);
gboolean sound_device_get_is_default (SoundDevice* self);
static void sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self,
                                                  SoundDevice* value);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean __lambda5_ (Block3Data* _data3_,
                     pa_operation* operation);
static gboolean ___lambda5__gee_forall_func (gpointer g,
                                      gpointer self);
static void sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self,
                                                   SoundDevice* value);
SoundDevice* sound_pulse_audio_manager_get_default_output (SoundPulseAudioManager* self);
SoundDevice* sound_pulse_audio_manager_get_default_input (SoundPulseAudioManager* self);
static GObject * sound_pulse_audio_manager_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void sound_pulse_audio_manager_finalize (GObject * obj);
static void _vala_sound_pulse_audio_manager_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_sound_pulse_audio_manager_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);


static inline gpointer
sound_pulse_audio_manager_get_instance_private (SoundPulseAudioManager* self)
{
	return G_STRUCT_MEMBER_P (self, SoundPulseAudioManager_private_offset);
}


SoundPulseAudioManager*
sound_pulse_audio_manager_get_default (void)
{
	SoundPulseAudioManager* result = NULL;
	SoundPulseAudioManager* _tmp0_;
	SoundPulseAudioManager* _tmp2_;
#line 32 "../src/PulseAudioManager.vala"
	_tmp0_ = sound_pulse_audio_manager_pam;
#line 32 "../src/PulseAudioManager.vala"
	if (_tmp0_ == NULL) {
#line 386 "PulseAudioManager.c"
		SoundPulseAudioManager* _tmp1_;
#line 33 "../src/PulseAudioManager.vala"
		_tmp1_ = sound_pulse_audio_manager_new ();
#line 33 "../src/PulseAudioManager.vala"
		_g_object_unref0 (sound_pulse_audio_manager_pam);
#line 33 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_pam = _tmp1_;
#line 394 "PulseAudioManager.c"
	}
#line 36 "../src/PulseAudioManager.vala"
	_tmp2_ = sound_pulse_audio_manager_pam;
#line 36 "../src/PulseAudioManager.vala"
	result = _tmp2_;
#line 36 "../src/PulseAudioManager.vala"
	return result;
#line 402 "PulseAudioManager.c"
}


static SoundPulseAudioManager*
sound_pulse_audio_manager_construct (GType object_type)
{
	SoundPulseAudioManager * self = NULL;
#line 53 "../src/PulseAudioManager.vala"
	self = (SoundPulseAudioManager*) g_object_new (object_type, NULL);
#line 53 "../src/PulseAudioManager.vala"
	return self;
#line 414 "PulseAudioManager.c"
}


static SoundPulseAudioManager*
sound_pulse_audio_manager_new (void)
{
#line 53 "../src/PulseAudioManager.vala"
	return sound_pulse_audio_manager_construct (SOUND_TYPE_PULSE_AUDIO_MANAGER);
#line 423 "PulseAudioManager.c"
}


void
sound_pulse_audio_manager_start (SoundPulseAudioManager* self)
{
#line 64 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
#line 434 "PulseAudioManager.c"
}


static void
_sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                           pa_ext_stream_restore_info* info,
                                                                                                           gint eol,
                                                                                                           gpointer self)
{
#line 73 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_ext_stream_restore_read_source_callback ((SoundPulseAudioManager*) self, c, info, eol);
#line 446 "PulseAudioManager.c"
}


static void
_sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                         pa_ext_stream_restore_info* info,
                                                                                                         gint eol,
                                                                                                         gpointer self)
{
#line 79 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_ext_stream_restore_read_sink_callback ((SoundPulseAudioManager*) self, c, info, eol);
#line 458 "PulseAudioManager.c"
}


void
sound_pulse_audio_manager_set_default_device (SoundPulseAudioManager* self,
                                              SoundDevice* device)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 68 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/PulseAudioManager.vala"
	g_return_if_fail (device != NULL);
#line 69 "../src/PulseAudioManager.vala"
	_tmp0_ = sound_device_get_input (device);
#line 69 "../src/PulseAudioManager.vala"
	_tmp1_ = _tmp0_;
#line 69 "../src/PulseAudioManager.vala"
	if (_tmp1_) {
#line 478 "PulseAudioManager.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		pa_operation* ope = NULL;
		pa_context* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		pa_operation* _tmp8_;
		pa_operation* _tmp9_;
#line 70 "../src/PulseAudioManager.vala"
		_tmp2_ = sound_device_get_name (device);
#line 70 "../src/PulseAudioManager.vala"
		_tmp3_ = _tmp2_;
#line 70 "../src/PulseAudioManager.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 70 "../src/PulseAudioManager.vala"
		_g_free0 (self->priv->default_source_name);
#line 70 "../src/PulseAudioManager.vala"
		self->priv->default_source_name = _tmp4_;
#line 71 "../src/PulseAudioManager.vala"
		_tmp5_ = self->priv->_context;
#line 71 "../src/PulseAudioManager.vala"
		_tmp6_ = sound_device_get_name (device);
#line 71 "../src/PulseAudioManager.vala"
		_tmp7_ = _tmp6_;
#line 71 "../src/PulseAudioManager.vala"
		_tmp8_ = pa_context_set_default_source (_tmp5_, _tmp7_, NULL, NULL);
#line 71 "../src/PulseAudioManager.vala"
		ope = _tmp8_;
#line 72 "../src/PulseAudioManager.vala"
		_tmp9_ = ope;
#line 72 "../src/PulseAudioManager.vala"
		if (_tmp9_ != NULL) {
#line 512 "PulseAudioManager.c"
			pa_context* _tmp10_;
			pa_operation* _tmp11_;
			pa_operation* _tmp12_;
#line 73 "../src/PulseAudioManager.vala"
			_tmp10_ = self->priv->_context;
#line 73 "../src/PulseAudioManager.vala"
			_tmp11_ = pa_ext_stream_restore_read (_tmp10_, _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb, self);
#line 73 "../src/PulseAudioManager.vala"
			_tmp12_ = _tmp11_;
#line 73 "../src/PulseAudioManager.vala"
			_pa_operation_unref0 (_tmp12_);
#line 524 "PulseAudioManager.c"
		}
#line 69 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (ope);
#line 528 "PulseAudioManager.c"
	} else {
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		pa_operation* ope = NULL;
		pa_context* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		pa_operation* _tmp19_;
		pa_operation* _tmp20_;
#line 76 "../src/PulseAudioManager.vala"
		_tmp13_ = sound_device_get_name (device);
#line 76 "../src/PulseAudioManager.vala"
		_tmp14_ = _tmp13_;
#line 76 "../src/PulseAudioManager.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 76 "../src/PulseAudioManager.vala"
		_g_free0 (self->priv->default_sink_name);
#line 76 "../src/PulseAudioManager.vala"
		self->priv->default_sink_name = _tmp15_;
#line 77 "../src/PulseAudioManager.vala"
		_tmp16_ = self->priv->_context;
#line 77 "../src/PulseAudioManager.vala"
		_tmp17_ = sound_device_get_name (device);
#line 77 "../src/PulseAudioManager.vala"
		_tmp18_ = _tmp17_;
#line 77 "../src/PulseAudioManager.vala"
		_tmp19_ = pa_context_set_default_sink (_tmp16_, _tmp18_, NULL, NULL);
#line 77 "../src/PulseAudioManager.vala"
		ope = _tmp19_;
#line 78 "../src/PulseAudioManager.vala"
		_tmp20_ = ope;
#line 78 "../src/PulseAudioManager.vala"
		if (_tmp20_ != NULL) {
#line 563 "PulseAudioManager.c"
			pa_context* _tmp21_;
			pa_operation* _tmp22_;
			pa_operation* _tmp23_;
#line 79 "../src/PulseAudioManager.vala"
			_tmp21_ = self->priv->_context;
#line 79 "../src/PulseAudioManager.vala"
			_tmp22_ = pa_ext_stream_restore_read (_tmp21_, _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb, self);
#line 79 "../src/PulseAudioManager.vala"
			_tmp23_ = _tmp22_;
#line 79 "../src/PulseAudioManager.vala"
			_pa_operation_unref0 (_tmp23_);
#line 575 "PulseAudioManager.c"
		}
#line 69 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (ope);
#line 579 "PulseAudioManager.c"
	}
}


void
sound_pulse_audio_manager_change_device_mute (SoundPulseAudioManager* self,
                                              SoundDevice* device,
                                              gboolean mute)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 84 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 84 "../src/PulseAudioManager.vala"
	g_return_if_fail (device != NULL);
#line 85 "../src/PulseAudioManager.vala"
	_tmp0_ = sound_device_get_input (device);
#line 85 "../src/PulseAudioManager.vala"
	_tmp1_ = _tmp0_;
#line 85 "../src/PulseAudioManager.vala"
	if (_tmp1_) {
#line 601 "PulseAudioManager.c"
		pa_context* _tmp2_;
		guint32 _tmp3_;
		guint32 _tmp4_;
		pa_operation* _tmp5_;
		pa_operation* _tmp6_;
#line 86 "../src/PulseAudioManager.vala"
		_tmp2_ = self->priv->_context;
#line 86 "../src/PulseAudioManager.vala"
		_tmp3_ = sound_device_get_index (device);
#line 86 "../src/PulseAudioManager.vala"
		_tmp4_ = _tmp3_;
#line 86 "../src/PulseAudioManager.vala"
		_tmp5_ = pa_context_set_source_mute_by_index (_tmp2_, _tmp4_, mute, NULL, NULL);
#line 86 "../src/PulseAudioManager.vala"
		_tmp6_ = _tmp5_;
#line 86 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (_tmp6_);
#line 619 "PulseAudioManager.c"
	} else {
		pa_context* _tmp7_;
		guint32 _tmp8_;
		guint32 _tmp9_;
		pa_operation* _tmp10_;
		pa_operation* _tmp11_;
#line 88 "../src/PulseAudioManager.vala"
		_tmp7_ = self->priv->_context;
#line 88 "../src/PulseAudioManager.vala"
		_tmp8_ = sound_device_get_index (device);
#line 88 "../src/PulseAudioManager.vala"
		_tmp9_ = _tmp8_;
#line 88 "../src/PulseAudioManager.vala"
		_tmp10_ = pa_context_set_sink_mute_by_index (_tmp7_, _tmp9_, mute, NULL, NULL);
#line 88 "../src/PulseAudioManager.vala"
		_tmp11_ = _tmp10_;
#line 88 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (_tmp11_);
#line 638 "PulseAudioManager.c"
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 92 "../src/PulseAudioManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 648 "PulseAudioManager.c"
}


static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 92 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 92 "../src/PulseAudioManager.vala"
	return _data1_;
#line 659 "PulseAudioManager.c"
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 92 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 670 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 92 "../src/PulseAudioManager.vala"
		self = _data1_->self;
#line 92 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_data1_->device);
#line 92 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 92 "../src/PulseAudioManager.vala"
		g_slice_free (Block1Data, _data1_);
#line 680 "PulseAudioManager.c"
	}
}


static gboolean
__lambda7_ (Block1Data* _data1_,
            pa_operation* operation)
{
	SoundPulseAudioManager* self;
	gboolean result = FALSE;
	GeeLinkedList* _tmp0_;
#line 93 "../src/PulseAudioManager.vala"
	self = _data1_->self;
#line 93 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (operation != NULL, FALSE);
#line 94 "../src/PulseAudioManager.vala"
	if (pa_operation_get_state (operation) == PA_OPERATION_RUNNING) {
#line 95 "../src/PulseAudioManager.vala"
		pa_operation_cancel (operation);
#line 700 "PulseAudioManager.c"
	}
#line 98 "../src/PulseAudioManager.vala"
	_tmp0_ = _data1_->device->volume_operations;
#line 98 "../src/PulseAudioManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, operation);
#line 99 "../src/PulseAudioManager.vala"
	result = G_SOURCE_CONTINUE;
#line 99 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (operation);
#line 99 "../src/PulseAudioManager.vala"
	return result;
#line 712 "PulseAudioManager.c"
}


static gboolean
___lambda7__gee_forall_func (gpointer g,
                             gpointer self)
{
	gboolean result;
	result = __lambda7_ (self, (pa_operation*) g);
#line 93 "../src/PulseAudioManager.vala"
	return result;
#line 724 "PulseAudioManager.c"
}


void
sound_pulse_audio_manager_change_device_volume (SoundPulseAudioManager* self,
                                                SoundDevice* device,
                                                gdouble volume)
{
	Block1Data* _data1_;
	SoundDevice* _tmp0_;
	GeeLinkedList* _tmp1_;
	pa_cvolume cvol = {0};
	pa_cvolume _tmp2_ = {0};
	pa_cvolume _tmp3_;
	pa_operation* operation = NULL;
	gboolean _tmp4_;
	gboolean _tmp5_;
	pa_operation* _tmp16_;
#line 92 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/PulseAudioManager.vala"
	g_return_if_fail (device != NULL);
#line 92 "../src/PulseAudioManager.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 92 "../src/PulseAudioManager.vala"
	_data1_->_ref_count_ = 1;
#line 92 "../src/PulseAudioManager.vala"
	_data1_->self = g_object_ref (self);
#line 92 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (device);
#line 92 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data1_->device);
#line 92 "../src/PulseAudioManager.vala"
	_data1_->device = _tmp0_;
#line 93 "../src/PulseAudioManager.vala"
	_tmp1_ = _data1_->device->volume_operations;
#line 93 "../src/PulseAudioManager.vala"
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp1_, ___lambda7__gee_forall_func, _data1_);
#line 102 "../src/PulseAudioManager.vala"
	sound_device_get_cvolume (_data1_->device, &_tmp2_);
#line 102 "../src/PulseAudioManager.vala"
	_tmp3_ = _tmp2_;
#line 102 "../src/PulseAudioManager.vala"
	cvol = _tmp3_;
#line 103 "../src/PulseAudioManager.vala"
	pa_cvolume_scale (&cvol, sound_pulse_audio_manager_double_to_volume (volume));
#line 104 "../src/PulseAudioManager.vala"
	operation = NULL;
#line 105 "../src/PulseAudioManager.vala"
	_tmp4_ = sound_device_get_input (_data1_->device);
#line 105 "../src/PulseAudioManager.vala"
	_tmp5_ = _tmp4_;
#line 105 "../src/PulseAudioManager.vala"
	if (_tmp5_) {
#line 779 "PulseAudioManager.c"
		pa_context* _tmp6_;
		guint32 _tmp7_;
		guint32 _tmp8_;
		pa_cvolume _tmp9_;
		pa_operation* _tmp10_;
#line 106 "../src/PulseAudioManager.vala"
		_tmp6_ = self->priv->_context;
#line 106 "../src/PulseAudioManager.vala"
		_tmp7_ = sound_device_get_index (_data1_->device);
#line 106 "../src/PulseAudioManager.vala"
		_tmp8_ = _tmp7_;
#line 106 "../src/PulseAudioManager.vala"
		_tmp9_ = cvol;
#line 106 "../src/PulseAudioManager.vala"
		_tmp10_ = pa_context_set_source_volume_by_index (_tmp6_, _tmp8_, &_tmp9_, NULL, NULL);
#line 106 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (operation);
#line 106 "../src/PulseAudioManager.vala"
		operation = _tmp10_;
#line 799 "PulseAudioManager.c"
	} else {
		pa_context* _tmp11_;
		guint32 _tmp12_;
		guint32 _tmp13_;
		pa_cvolume _tmp14_;
		pa_operation* _tmp15_;
#line 108 "../src/PulseAudioManager.vala"
		_tmp11_ = self->priv->_context;
#line 108 "../src/PulseAudioManager.vala"
		_tmp12_ = sound_device_get_index (_data1_->device);
#line 108 "../src/PulseAudioManager.vala"
		_tmp13_ = _tmp12_;
#line 108 "../src/PulseAudioManager.vala"
		_tmp14_ = cvol;
#line 108 "../src/PulseAudioManager.vala"
		_tmp15_ = pa_context_set_sink_volume_by_index (_tmp11_, _tmp13_, &_tmp14_, NULL, NULL);
#line 108 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (operation);
#line 108 "../src/PulseAudioManager.vala"
		operation = _tmp15_;
#line 820 "PulseAudioManager.c"
	}
#line 111 "../src/PulseAudioManager.vala"
	_tmp16_ = operation;
#line 111 "../src/PulseAudioManager.vala"
	if (_tmp16_ != NULL) {
#line 826 "PulseAudioManager.c"
		GeeLinkedList* _tmp17_;
		pa_operation* _tmp18_;
#line 112 "../src/PulseAudioManager.vala"
		_tmp17_ = _data1_->device->volume_operations;
#line 112 "../src/PulseAudioManager.vala"
		_tmp18_ = operation;
#line 112 "../src/PulseAudioManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp18_);
#line 835 "PulseAudioManager.c"
	}
#line 92 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (operation);
#line 92 "../src/PulseAudioManager.vala"
	block1_data_unref (_data1_);
#line 92 "../src/PulseAudioManager.vala"
	_data1_ = NULL;
#line 843 "PulseAudioManager.c"
}


void
sound_pulse_audio_manager_change_device_balance (SoundPulseAudioManager* self,
                                                 SoundDevice* device,
                                                 gfloat balance)
{
	pa_cvolume cvol = {0};
	pa_cvolume _tmp0_ = {0};
	pa_cvolume _tmp1_;
	pa_channel_map _tmp2_ = {0};
	pa_channel_map _tmp3_;
	pa_operation* operation = NULL;
	gboolean _tmp4_;
	gboolean _tmp5_;
	pa_operation* _tmp16_;
#line 116 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/PulseAudioManager.vala"
	g_return_if_fail (device != NULL);
#line 117 "../src/PulseAudioManager.vala"
	sound_device_get_cvolume (device, &_tmp0_);
#line 117 "../src/PulseAudioManager.vala"
	_tmp1_ = _tmp0_;
#line 117 "../src/PulseAudioManager.vala"
	cvol = _tmp1_;
#line 118 "../src/PulseAudioManager.vala"
	sound_device_get_channel_map (device, &_tmp2_);
#line 118 "../src/PulseAudioManager.vala"
	_tmp3_ = _tmp2_;
#line 118 "../src/PulseAudioManager.vala"
	cvol = *pa_cvolume_set_balance (&cvol, &_tmp3_, balance);
#line 119 "../src/PulseAudioManager.vala"
	operation = NULL;
#line 120 "../src/PulseAudioManager.vala"
	_tmp4_ = sound_device_get_input (device);
#line 120 "../src/PulseAudioManager.vala"
	_tmp5_ = _tmp4_;
#line 120 "../src/PulseAudioManager.vala"
	if (_tmp5_) {
#line 885 "PulseAudioManager.c"
		pa_context* _tmp6_;
		guint32 _tmp7_;
		guint32 _tmp8_;
		pa_cvolume _tmp9_;
		pa_operation* _tmp10_;
#line 121 "../src/PulseAudioManager.vala"
		_tmp6_ = self->priv->_context;
#line 121 "../src/PulseAudioManager.vala"
		_tmp7_ = sound_device_get_index (device);
#line 121 "../src/PulseAudioManager.vala"
		_tmp8_ = _tmp7_;
#line 121 "../src/PulseAudioManager.vala"
		_tmp9_ = cvol;
#line 121 "../src/PulseAudioManager.vala"
		_tmp10_ = pa_context_set_source_volume_by_index (_tmp6_, _tmp8_, &_tmp9_, NULL, NULL);
#line 121 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (operation);
#line 121 "../src/PulseAudioManager.vala"
		operation = _tmp10_;
#line 905 "PulseAudioManager.c"
	} else {
		pa_context* _tmp11_;
		guint32 _tmp12_;
		guint32 _tmp13_;
		pa_cvolume _tmp14_;
		pa_operation* _tmp15_;
#line 123 "../src/PulseAudioManager.vala"
		_tmp11_ = self->priv->_context;
#line 123 "../src/PulseAudioManager.vala"
		_tmp12_ = sound_device_get_index (device);
#line 123 "../src/PulseAudioManager.vala"
		_tmp13_ = _tmp12_;
#line 123 "../src/PulseAudioManager.vala"
		_tmp14_ = cvol;
#line 123 "../src/PulseAudioManager.vala"
		_tmp15_ = pa_context_set_sink_volume_by_index (_tmp11_, _tmp13_, &_tmp14_, NULL, NULL);
#line 123 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (operation);
#line 123 "../src/PulseAudioManager.vala"
		operation = _tmp15_;
#line 926 "PulseAudioManager.c"
	}
#line 126 "../src/PulseAudioManager.vala"
	_tmp16_ = operation;
#line 126 "../src/PulseAudioManager.vala"
	if (_tmp16_ != NULL) {
#line 932 "PulseAudioManager.c"
		GeeLinkedList* _tmp17_;
		pa_operation* _tmp18_;
#line 127 "../src/PulseAudioManager.vala"
		_tmp17_ = device->volume_operations;
#line 127 "../src/PulseAudioManager.vala"
		_tmp18_ = operation;
#line 127 "../src/PulseAudioManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp18_);
#line 941 "PulseAudioManager.c"
	}
#line 116 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (operation);
#line 945 "PulseAudioManager.c"
}


static gboolean
sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self)
{
	gboolean result = FALSE;
#line 135 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 136 "../src/PulseAudioManager.vala"
	self->priv->reconnect_timer_id = 0U;
#line 137 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
#line 138 "../src/PulseAudioManager.vala"
	result = FALSE;
#line 138 "../src/PulseAudioManager.vala"
	return result;
#line 963 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerReconnectToPulseData, _data_);
#line 976 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_reconnect_to_pulse_async_ready_wrapper (GObject *source_object,
                                                                  GAsyncResult *res,
                                                                  void *user_data)
{
	SoundPulseAudioManagerReconnectToPulseData* _task_data_;
#line 29 "../src/PulseAudioManager.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 29 "../src/PulseAudioManager.vala"
	if (_task_data_->_callback_ != NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 992 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	_task_data_->_task_complete_ = TRUE;
#line 996 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	SoundPulseAudioManager* _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerReconnectToPulseData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_callback_ = _callback_;
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, sound_pulse_audio_manager_reconnect_to_pulse_async_ready_wrapper, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	if (_callback_ == NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_data_->_task_complete_ = TRUE;
#line 1017 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_reconnect_to_pulse_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_reconnect_to_pulse_co (_data_);
#line 1027 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1038 "PulseAudioManager.c"
}


static void
_sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                          gpointer self)
{
#line 151 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_context_state_callback ((SoundPulseAudioManager*) self, c);
#line 1048 "PulseAudioManager.c"
}


static gboolean
sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_)
{
#line 141 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 141 "../src/PulseAudioManager.vala"
		case 0:
#line 1059 "PulseAudioManager.c"
		goto _state_0;
		default:
#line 141 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 1064 "PulseAudioManager.c"
	}
	_state_0:
#line 142 "../src/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->is_ready;
#line 142 "../src/PulseAudioManager.vala"
	if (_data_->_tmp0_) {
#line 143 "../src/PulseAudioManager.vala"
		_data_->_tmp1_ = _data_->self->priv->_context;
#line 143 "../src/PulseAudioManager.vala"
		pa_context_disconnect (_data_->_tmp1_);
#line 144 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_context (_data_->self, NULL);
#line 145 "../src/PulseAudioManager.vala"
		_data_->self->priv->is_ready = FALSE;
#line 1079 "PulseAudioManager.c"
	}
#line 148 "../src/PulseAudioManager.vala"
	_data_->_tmp2_ = pa_proplist_new ();
#line 148 "../src/PulseAudioManager.vala"
	_data_->props = _data_->_tmp2_;
#line 149 "../src/PulseAudioManager.vala"
	_data_->_tmp3_ = _data_->props;
#line 149 "../src/PulseAudioManager.vala"
	pa_proplist_sets (_data_->_tmp3_, PA_PROP_APPLICATION_ID, "org.pantheon.switchboard.plug.sound");
#line 150 "../src/PulseAudioManager.vala"
	_data_->_tmp4_ = _data_->self->priv->loop;
#line 150 "../src/PulseAudioManager.vala"
	_data_->_tmp5_ = pa_glib_mainloop_get_api (_data_->_tmp4_);
#line 150 "../src/PulseAudioManager.vala"
	_data_->_tmp6_ = _data_->props;
#line 150 "../src/PulseAudioManager.vala"
	_data_->_tmp7_ = pa_context_new_with_proplist (_data_->_tmp5_, NULL, _data_->_tmp6_);
#line 150 "../src/PulseAudioManager.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 150 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_context (_data_->self, _data_->_tmp8_);
#line 150 "../src/PulseAudioManager.vala"
	_pa_context_unref0 (_data_->_tmp8_);
#line 151 "../src/PulseAudioManager.vala"
	_data_->_tmp9_ = _data_->self->priv->_context;
#line 151 "../src/PulseAudioManager.vala"
	pa_context_set_state_callback (_data_->_tmp9_, _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t, _data_->self);
#line 153 "../src/PulseAudioManager.vala"
	_data_->_tmp10_ = _data_->self->priv->_context;
#line 153 "../src/PulseAudioManager.vala"
	if (pa_context_connect (_data_->_tmp10_, NULL, PA_CONTEXT_NOFAIL, NULL) < 0) {
#line 154 "../src/PulseAudioManager.vala"
		_data_->_tmp11_ = _data_->self->priv->_context;
#line 154 "../src/PulseAudioManager.vala"
		_data_->_tmp12_ = pa_strerror (pa_context_errno (_data_->_tmp11_));
#line 154 "../src/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:154: pa_context_connect() failed: %s\n", _data_->_tmp12_);
#line 1117 "PulseAudioManager.c"
	}
#line 141 "../src/PulseAudioManager.vala"
	_pa_proplist_free0 (_data_->props);
#line 141 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 141 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 141 "../src/PulseAudioManager.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 141 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1129 "PulseAudioManager.c"
		}
	}
#line 141 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 141 "../src/PulseAudioManager.vala"
	return FALSE;
#line 1136 "PulseAudioManager.c"
}


static void
_sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                         pa_subscription_event_type_t t,
                                                                         guint32 idx,
                                                                         gpointer self)
{
#line 161 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_subscribe_callback ((SoundPulseAudioManager*) self, c, t, idx);
#line 1148 "PulseAudioManager.c"
}


static void
_sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                                     pa_server_info* i,
                                                                     gpointer self)
{
#line 167 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_server_info_callback ((SoundPulseAudioManager*) self, c, i);
#line 1159 "PulseAudioManager.c"
}


static gboolean
_sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = sound_pulse_audio_manager_reconnect_timeout ((SoundPulseAudioManager*) self);
#line 174 "../src/PulseAudioManager.vala"
	return result;
#line 1170 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self,
                                                  pa_context* c)
{
#line 158 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 159 "../src/PulseAudioManager.vala"
	switch (pa_context_get_state (c)) {
#line 159 "../src/PulseAudioManager.vala"
		case PA_CONTEXT_READY:
#line 1186 "PulseAudioManager.c"
		{
			pa_operation* _tmp0_;
			pa_operation* _tmp1_;
			pa_context* _tmp2_;
			pa_operation* _tmp3_;
			pa_operation* _tmp4_;
#line 161 "../src/PulseAudioManager.vala"
			pa_context_set_subscribe_callback (c, _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t, self);
#line 162 "../src/PulseAudioManager.vala"
			_tmp0_ = pa_context_subscribe (c, (((PA_SUBSCRIPTION_MASK_SERVER | PA_SUBSCRIPTION_MASK_SINK) | PA_SUBSCRIPTION_MASK_SOURCE) | PA_SUBSCRIPTION_MASK_SINK_INPUT) | PA_SUBSCRIPTION_MASK_SOURCE_OUTPUT, NULL, NULL);
#line 162 "../src/PulseAudioManager.vala"
			_tmp1_ = _tmp0_;
#line 162 "../src/PulseAudioManager.vala"
			_pa_operation_unref0 (_tmp1_);
#line 167 "../src/PulseAudioManager.vala"
			_tmp2_ = self->priv->_context;
#line 167 "../src/PulseAudioManager.vala"
			_tmp3_ = pa_context_get_server_info (_tmp2_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
#line 167 "../src/PulseAudioManager.vala"
			_tmp4_ = _tmp3_;
#line 167 "../src/PulseAudioManager.vala"
			_pa_operation_unref0 (_tmp4_);
#line 168 "../src/PulseAudioManager.vala"
			self->priv->is_ready = TRUE;
#line 169 "../src/PulseAudioManager.vala"
			break;
#line 1213 "PulseAudioManager.c"
		}
#line 159 "../src/PulseAudioManager.vala"
		case PA_CONTEXT_FAILED:
#line 159 "../src/PulseAudioManager.vala"
		case PA_CONTEXT_TERMINATED:
#line 1219 "PulseAudioManager.c"
		{
			guint _tmp5_;
#line 173 "../src/PulseAudioManager.vala"
			_tmp5_ = self->priv->reconnect_timer_id;
#line 173 "../src/PulseAudioManager.vala"
			if (_tmp5_ == 0U) {
#line 174 "../src/PulseAudioManager.vala"
				self->priv->reconnect_timer_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _sound_pulse_audio_manager_reconnect_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 1228 "PulseAudioManager.c"
			}
#line 175 "../src/PulseAudioManager.vala"
			break;
#line 1232 "PulseAudioManager.c"
		}
		default:
		{
#line 178 "../src/PulseAudioManager.vala"
			self->priv->is_ready = FALSE;
#line 179 "../src/PulseAudioManager.vala"
			break;
#line 1240 "PulseAudioManager.c"
		}
	}
}


static void
_sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c,
                                                                 pa_sink_info* i,
                                                                 gint eol,
                                                                 gpointer self)
{
#line 195 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_sink_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
#line 1254 "PulseAudioManager.c"
}


static void
_sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c,
                                                                     pa_source_info* i,
                                                                     gint eol,
                                                                     gpointer self)
{
#line 223 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_source_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
#line 1266 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_subscription_event_type_t t,
                                              guint32 index)
{
	pa_subscription_event_type_t source_type = 0;
	pa_subscription_event_type_t _tmp0_;
#line 187 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 188 "../src/PulseAudioManager.vala"
	source_type = t & PA_SUBSCRIPTION_EVENT_FACILITY_MASK;
#line 189 "../src/PulseAudioManager.vala"
	_tmp0_ = source_type;
#line 189 "../src/PulseAudioManager.vala"
	switch (_tmp0_) {
#line 189 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SINK:
#line 189 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SINK_INPUT:
#line 1292 "PulseAudioManager.c"
		{
			pa_subscription_event_type_t event_type = 0;
			pa_subscription_event_type_t _tmp1_;
#line 192 "../src/PulseAudioManager.vala"
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
#line 193 "../src/PulseAudioManager.vala"
			_tmp1_ = event_type;
#line 193 "../src/PulseAudioManager.vala"
			switch (_tmp1_) {
#line 193 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_NEW:
#line 1304 "PulseAudioManager.c"
				{
					pa_operation* _tmp2_;
					pa_operation* _tmp3_;
#line 195 "../src/PulseAudioManager.vala"
					_tmp2_ = pa_context_get_sink_info_by_index (c, index, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
#line 195 "../src/PulseAudioManager.vala"
					_tmp3_ = _tmp2_;
#line 195 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp3_);
#line 196 "../src/PulseAudioManager.vala"
					break;
#line 1316 "PulseAudioManager.c"
				}
#line 193 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_CHANGE:
#line 1320 "PulseAudioManager.c"
				{
					pa_operation* _tmp4_;
					pa_operation* _tmp5_;
#line 199 "../src/PulseAudioManager.vala"
					_tmp4_ = pa_context_get_sink_info_by_index (c, index, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
#line 199 "../src/PulseAudioManager.vala"
					_tmp5_ = _tmp4_;
#line 199 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp5_);
#line 200 "../src/PulseAudioManager.vala"
					break;
#line 1332 "PulseAudioManager.c"
				}
#line 193 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_REMOVE:
#line 1336 "PulseAudioManager.c"
				{
					SoundDevice* device = NULL;
					GeeHashMap* _tmp6_;
					gpointer _tmp7_;
					SoundDevice* _tmp8_;
#line 203 "../src/PulseAudioManager.vala"
					_tmp6_ = self->priv->output_devices;
#line 203 "../src/PulseAudioManager.vala"
					_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, (gpointer) ((guintptr) index));
#line 203 "../src/PulseAudioManager.vala"
					device = (SoundDevice*) _tmp7_;
#line 204 "../src/PulseAudioManager.vala"
					_tmp8_ = device;
#line 204 "../src/PulseAudioManager.vala"
					if (_tmp8_ != NULL) {
#line 1352 "PulseAudioManager.c"
						SoundDevice* _tmp9_;
						GeeHashMap* _tmp10_;
#line 205 "../src/PulseAudioManager.vala"
						_tmp9_ = device;
#line 205 "../src/PulseAudioManager.vala"
						g_signal_emit_by_name (_tmp9_, "removed");
#line 206 "../src/PulseAudioManager.vala"
						_tmp10_ = self->priv->output_devices;
#line 206 "../src/PulseAudioManager.vala"
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp10_, (gpointer) ((guintptr) index), NULL);
#line 1363 "PulseAudioManager.c"
					}
#line 209 "../src/PulseAudioManager.vala"
					_g_object_unref0 (device);
#line 209 "../src/PulseAudioManager.vala"
					break;
#line 1369 "PulseAudioManager.c"
				}
				default:
#line 193 "../src/PulseAudioManager.vala"
				break;
#line 1374 "PulseAudioManager.c"
			}
#line 212 "../src/PulseAudioManager.vala"
			break;
#line 1378 "PulseAudioManager.c"
		}
#line 189 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SERVER:
#line 1382 "PulseAudioManager.c"
		{
			pa_context* _tmp11_;
			pa_operation* _tmp12_;
			pa_operation* _tmp13_;
#line 215 "../src/PulseAudioManager.vala"
			_tmp11_ = self->priv->_context;
#line 215 "../src/PulseAudioManager.vala"
			_tmp12_ = pa_context_get_server_info (_tmp11_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
#line 215 "../src/PulseAudioManager.vala"
			_tmp13_ = _tmp12_;
#line 215 "../src/PulseAudioManager.vala"
			_pa_operation_unref0 (_tmp13_);
#line 216 "../src/PulseAudioManager.vala"
			break;
#line 1397 "PulseAudioManager.c"
		}
#line 189 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SOURCE:
#line 189 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SOURCE_OUTPUT:
#line 1403 "PulseAudioManager.c"
		{
			pa_subscription_event_type_t event_type = 0;
			pa_subscription_event_type_t _tmp14_;
#line 220 "../src/PulseAudioManager.vala"
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
#line 221 "../src/PulseAudioManager.vala"
			_tmp14_ = event_type;
#line 221 "../src/PulseAudioManager.vala"
			switch (_tmp14_) {
#line 221 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_NEW:
#line 1415 "PulseAudioManager.c"
				{
					pa_operation* _tmp15_;
					pa_operation* _tmp16_;
#line 223 "../src/PulseAudioManager.vala"
					_tmp15_ = pa_context_get_source_info_by_index (c, index, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
#line 223 "../src/PulseAudioManager.vala"
					_tmp16_ = _tmp15_;
#line 223 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp16_);
#line 224 "../src/PulseAudioManager.vala"
					break;
#line 1427 "PulseAudioManager.c"
				}
#line 221 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_CHANGE:
#line 1431 "PulseAudioManager.c"
				{
					pa_operation* _tmp17_;
					pa_operation* _tmp18_;
#line 227 "../src/PulseAudioManager.vala"
					_tmp17_ = pa_context_get_source_info_by_index (c, index, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
#line 227 "../src/PulseAudioManager.vala"
					_tmp18_ = _tmp17_;
#line 227 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp18_);
#line 228 "../src/PulseAudioManager.vala"
					break;
#line 1443 "PulseAudioManager.c"
				}
#line 221 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_REMOVE:
#line 1447 "PulseAudioManager.c"
				{
					SoundDevice* device = NULL;
					GeeHashMap* _tmp19_;
					gpointer _tmp20_;
					SoundDevice* _tmp21_;
#line 231 "../src/PulseAudioManager.vala"
					_tmp19_ = self->priv->input_devices;
#line 231 "../src/PulseAudioManager.vala"
					_tmp20_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp19_, (gpointer) ((guintptr) index));
#line 231 "../src/PulseAudioManager.vala"
					device = (SoundDevice*) _tmp20_;
#line 232 "../src/PulseAudioManager.vala"
					_tmp21_ = device;
#line 232 "../src/PulseAudioManager.vala"
					if (_tmp21_ != NULL) {
#line 1463 "PulseAudioManager.c"
						SoundDevice* _tmp22_;
						GeeHashMap* _tmp23_;
#line 233 "../src/PulseAudioManager.vala"
						_tmp22_ = device;
#line 233 "../src/PulseAudioManager.vala"
						g_signal_emit_by_name (_tmp22_, "removed");
#line 234 "../src/PulseAudioManager.vala"
						_tmp23_ = self->priv->input_devices;
#line 234 "../src/PulseAudioManager.vala"
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp23_, (gpointer) ((guintptr) index), NULL);
#line 1474 "PulseAudioManager.c"
					}
#line 237 "../src/PulseAudioManager.vala"
					_g_object_unref0 (device);
#line 237 "../src/PulseAudioManager.vala"
					break;
#line 1480 "PulseAudioManager.c"
				}
				default:
#line 221 "../src/PulseAudioManager.vala"
				break;
#line 1485 "PulseAudioManager.c"
			}
#line 240 "../src/PulseAudioManager.vala"
			break;
#line 1489 "PulseAudioManager.c"
		}
		default:
#line 189 "../src/PulseAudioManager.vala"
		break;
#line 1494 "PulseAudioManager.c"
	}
}


static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 248 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 248 "../src/PulseAudioManager.vala"
	return _data2_;
#line 1506 "PulseAudioManager.c"
}


static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 248 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1517 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 248 "../src/PulseAudioManager.vala"
		self = _data2_->self;
#line 248 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_data2_->device);
#line 248 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 248 "../src/PulseAudioManager.vala"
		g_slice_free (Block2Data, _data2_);
#line 1527 "PulseAudioManager.c"
	}
}


static gboolean
__lambda6_ (Block2Data* _data2_,
            pa_operation* operation)
{
	SoundPulseAudioManager* self;
	gboolean result = FALSE;
#line 272 "../src/PulseAudioManager.vala"
	self = _data2_->self;
#line 272 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (operation != NULL, FALSE);
#line 273 "../src/PulseAudioManager.vala"
	if (pa_operation_get_state (operation) != PA_OPERATION_RUNNING) {
#line 1544 "PulseAudioManager.c"
		SoundDevice* _tmp0_;
		GeeLinkedList* _tmp1_;
#line 274 "../src/PulseAudioManager.vala"
		_tmp0_ = _data2_->device;
#line 274 "../src/PulseAudioManager.vala"
		_tmp1_ = _tmp0_->volume_operations;
#line 274 "../src/PulseAudioManager.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, operation);
#line 1553 "PulseAudioManager.c"
	}
#line 277 "../src/PulseAudioManager.vala"
	result = G_SOURCE_CONTINUE;
#line 277 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (operation);
#line 277 "../src/PulseAudioManager.vala"
	return result;
#line 1561 "PulseAudioManager.c"
}


static gboolean
___lambda6__gee_forall_func (gpointer g,
                             gpointer self)
{
	gboolean result;
	result = __lambda6_ (self, (pa_operation*) g);
#line 272 "../src/PulseAudioManager.vala"
	return result;
#line 1573 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self,
                                                pa_context* c,
                                                pa_source_info* i,
                                                gint eol)
{
	Block2Data* _data2_;
	guint32 _tmp0_;
	gboolean is_new = FALSE;
	GeeHashMap* _tmp1_;
	guint32 _tmp2_;
	gboolean _tmp3_;
	SoundDevice* _tmp9_;
	SoundDevice* _tmp10_;
	const gchar* _tmp11_;
	SoundDevice* _tmp12_;
	const gchar* _tmp13_;
	SoundDevice* _tmp14_;
	gint _tmp15_;
	SoundDevice* _tmp16_;
	pa_cvolume _tmp17_;
	SoundDevice* _tmp18_;
	pa_channel_map _tmp19_;
	SoundDevice* _tmp20_;
	pa_channel_map _tmp21_;
	SoundDevice* _tmp22_;
	GeeLinkedList* _tmp23_;
	SoundDevice* _tmp24_;
	GeeArrayList* _tmp25_;
	GeeArrayList* _tmp26_;
	SoundDevice* _tmp27_;
	SoundDevice* _tmp60_;
	GeeLinkedList* _tmp61_;
	gboolean _tmp62_;
	gboolean _tmp63_;
	gchar* form_factor = NULL;
	pa_proplist* _tmp65_;
	const gchar* _tmp66_;
	gchar* _tmp67_;
	const gchar* _tmp68_;
	SoundDevice* _tmp71_;
	const gchar* _tmp72_;
	const gchar* _tmp73_;
	SoundDevice* _tmp74_;
	gboolean _tmp75_;
	gboolean _tmp76_;
	gboolean _tmp78_;
#line 248 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 248 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 248 "../src/PulseAudioManager.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 248 "../src/PulseAudioManager.vala"
	_data2_->_ref_count_ = 1;
#line 248 "../src/PulseAudioManager.vala"
	_data2_->self = g_object_ref (self);
#line 249 "../src/PulseAudioManager.vala"
	if (i == NULL) {
#line 250 "../src/PulseAudioManager.vala"
		block2_data_unref (_data2_);
#line 250 "../src/PulseAudioManager.vala"
		_data2_ = NULL;
#line 250 "../src/PulseAudioManager.vala"
		return;
#line 1642 "PulseAudioManager.c"
	}
#line 253 "../src/PulseAudioManager.vala"
	_tmp0_ = (*i).monitor_of_sink;
#line 253 "../src/PulseAudioManager.vala"
	if (_tmp0_ != PA_INVALID_INDEX) {
#line 254 "../src/PulseAudioManager.vala"
		block2_data_unref (_data2_);
#line 254 "../src/PulseAudioManager.vala"
		_data2_ = NULL;
#line 254 "../src/PulseAudioManager.vala"
		return;
#line 1654 "PulseAudioManager.c"
	}
#line 257 "../src/PulseAudioManager.vala"
	_data2_->device = NULL;
#line 258 "../src/PulseAudioManager.vala"
	_tmp1_ = self->priv->input_devices;
#line 258 "../src/PulseAudioManager.vala"
	_tmp2_ = (*i).index;
#line 258 "../src/PulseAudioManager.vala"
	is_new = !gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((guintptr) _tmp2_));
#line 259 "../src/PulseAudioManager.vala"
	_tmp3_ = is_new;
#line 259 "../src/PulseAudioManager.vala"
	if (_tmp3_) {
#line 1668 "PulseAudioManager.c"
		guint32 _tmp4_;
		SoundDevice* _tmp5_;
#line 260 "../src/PulseAudioManager.vala"
		_tmp4_ = (*i).index;
#line 260 "../src/PulseAudioManager.vala"
		_tmp5_ = sound_device_new (_tmp4_);
#line 260 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_data2_->device);
#line 260 "../src/PulseAudioManager.vala"
		_data2_->device = _tmp5_;
#line 1679 "PulseAudioManager.c"
	} else {
		GeeHashMap* _tmp6_;
		guint32 _tmp7_;
		gpointer _tmp8_;
#line 262 "../src/PulseAudioManager.vala"
		_tmp6_ = self->priv->input_devices;
#line 262 "../src/PulseAudioManager.vala"
		_tmp7_ = (*i).index;
#line 262 "../src/PulseAudioManager.vala"
		_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, (gpointer) ((guintptr) _tmp7_));
#line 262 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_data2_->device);
#line 262 "../src/PulseAudioManager.vala"
		_data2_->device = (SoundDevice*) _tmp8_;
#line 1694 "PulseAudioManager.c"
	}
#line 265 "../src/PulseAudioManager.vala"
	_tmp9_ = _data2_->device;
#line 265 "../src/PulseAudioManager.vala"
	sound_device_set_input (_tmp9_, TRUE);
#line 266 "../src/PulseAudioManager.vala"
	_tmp10_ = _data2_->device;
#line 266 "../src/PulseAudioManager.vala"
	_tmp11_ = (*i).name;
#line 266 "../src/PulseAudioManager.vala"
	sound_device_set_name (_tmp10_, _tmp11_);
#line 267 "../src/PulseAudioManager.vala"
	_tmp12_ = _data2_->device;
#line 267 "../src/PulseAudioManager.vala"
	_tmp13_ = (*i).description;
#line 267 "../src/PulseAudioManager.vala"
	sound_device_set_display_name (_tmp12_, _tmp13_);
#line 268 "../src/PulseAudioManager.vala"
	_tmp14_ = _data2_->device;
#line 268 "../src/PulseAudioManager.vala"
	_tmp15_ = (*i).mute;
#line 268 "../src/PulseAudioManager.vala"
	sound_device_set_is_muted (_tmp14_, _tmp15_ != 0);
#line 269 "../src/PulseAudioManager.vala"
	_tmp16_ = _data2_->device;
#line 269 "../src/PulseAudioManager.vala"
	_tmp17_ = (*i).volume;
#line 269 "../src/PulseAudioManager.vala"
	sound_device_set_cvolume (_tmp16_, &_tmp17_);
#line 270 "../src/PulseAudioManager.vala"
	_tmp18_ = _data2_->device;
#line 270 "../src/PulseAudioManager.vala"
	_tmp19_ = (*i).channel_map;
#line 270 "../src/PulseAudioManager.vala"
	sound_device_set_channel_map (_tmp18_, &_tmp19_);
#line 271 "../src/PulseAudioManager.vala"
	_tmp20_ = _data2_->device;
#line 271 "../src/PulseAudioManager.vala"
	_tmp21_ = (*i).channel_map;
#line 271 "../src/PulseAudioManager.vala"
	sound_device_set_balance (_tmp20_, pa_cvolume_get_balance (&(*i).volume, &_tmp21_));
#line 272 "../src/PulseAudioManager.vala"
	_tmp22_ = _data2_->device;
#line 272 "../src/PulseAudioManager.vala"
	_tmp23_ = _tmp22_->volume_operations;
#line 272 "../src/PulseAudioManager.vala"
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp23_, ___lambda6__gee_forall_func, _data2_);
#line 280 "../src/PulseAudioManager.vala"
	_tmp24_ = _data2_->device;
#line 280 "../src/PulseAudioManager.vala"
	_tmp25_ = sound_device_get_ports (_tmp24_);
#line 280 "../src/PulseAudioManager.vala"
	_tmp26_ = _tmp25_;
#line 280 "../src/PulseAudioManager.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp26_);
#line 281 "../src/PulseAudioManager.vala"
	_tmp27_ = _data2_->device;
#line 281 "../src/PulseAudioManager.vala"
	sound_device_set_default_port (_tmp27_, NULL);
#line 1754 "PulseAudioManager.c"
	{
		gint idx = 0;
#line 282 "../src/PulseAudioManager.vala"
		idx = 0;
#line 1759 "PulseAudioManager.c"
		{
			gboolean _tmp28_ = FALSE;
#line 282 "../src/PulseAudioManager.vala"
			_tmp28_ = TRUE;
#line 282 "../src/PulseAudioManager.vala"
			while (TRUE) {
#line 1766 "PulseAudioManager.c"
				gint _tmp30_;
				guint32 _tmp31_;
				SoundDevicePort* new_port = NULL;
				SoundDevicePort* _tmp32_;
				SoundDevicePort* _tmp33_;
				pa_source_port_info** _tmp34_;
				gint _tmp34__length1;
				gint _tmp35_;
				pa_source_port_info* _tmp36_;
				const gchar* _tmp37_;
				gchar* _tmp38_;
				SoundDevicePort* _tmp39_;
				pa_source_port_info** _tmp40_;
				gint _tmp40__length1;
				gint _tmp41_;
				pa_source_port_info* _tmp42_;
				const gchar* _tmp43_;
				gchar* _tmp44_;
				SoundDevicePort* _tmp45_;
				pa_source_port_info** _tmp46_;
				gint _tmp46__length1;
				gint _tmp47_;
				pa_source_port_info* _tmp48_;
				guint32 _tmp49_;
				SoundDevice* _tmp50_;
				GeeArrayList* _tmp51_;
				GeeArrayList* _tmp52_;
				SoundDevicePort* _tmp53_;
				pa_source_port_info** _tmp54_;
				gint _tmp54__length1;
				gint _tmp55_;
				pa_source_port_info* _tmp56_;
				pa_source_port_info* _tmp57_;
#line 282 "../src/PulseAudioManager.vala"
				if (!_tmp28_) {
#line 1802 "PulseAudioManager.c"
					gint _tmp29_;
#line 282 "../src/PulseAudioManager.vala"
					_tmp29_ = idx;
#line 282 "../src/PulseAudioManager.vala"
					idx = _tmp29_ + 1;
#line 1808 "PulseAudioManager.c"
				}
#line 282 "../src/PulseAudioManager.vala"
				_tmp28_ = FALSE;
#line 282 "../src/PulseAudioManager.vala"
				_tmp30_ = idx;
#line 282 "../src/PulseAudioManager.vala"
				_tmp31_ = (*i).n_ports;
#line 282 "../src/PulseAudioManager.vala"
				if (!(((guint32) _tmp30_) < _tmp31_)) {
#line 282 "../src/PulseAudioManager.vala"
					break;
#line 1820 "PulseAudioManager.c"
				}
#line 283 "../src/PulseAudioManager.vala"
				_tmp32_ = sound_device_port_new ();
#line 283 "../src/PulseAudioManager.vala"
				new_port = _tmp32_;
#line 284 "../src/PulseAudioManager.vala"
				_tmp33_ = new_port;
#line 284 "../src/PulseAudioManager.vala"
				_tmp34_ = (*i).ports;
#line 284 "../src/PulseAudioManager.vala"
				_tmp34__length1 = (*i).n_ports;
#line 284 "../src/PulseAudioManager.vala"
				_tmp35_ = idx;
#line 284 "../src/PulseAudioManager.vala"
				_tmp36_ = _tmp34_[_tmp35_];
#line 284 "../src/PulseAudioManager.vala"
				_tmp37_ = (*_tmp36_).name;
#line 284 "../src/PulseAudioManager.vala"
				_tmp38_ = g_strdup (_tmp37_);
#line 284 "../src/PulseAudioManager.vala"
				_g_free0 (_tmp33_->name);
#line 284 "../src/PulseAudioManager.vala"
				_tmp33_->name = _tmp38_;
#line 285 "../src/PulseAudioManager.vala"
				_tmp39_ = new_port;
#line 285 "../src/PulseAudioManager.vala"
				_tmp40_ = (*i).ports;
#line 285 "../src/PulseAudioManager.vala"
				_tmp40__length1 = (*i).n_ports;
#line 285 "../src/PulseAudioManager.vala"
				_tmp41_ = idx;
#line 285 "../src/PulseAudioManager.vala"
				_tmp42_ = _tmp40_[_tmp41_];
#line 285 "../src/PulseAudioManager.vala"
				_tmp43_ = (*_tmp42_).description;
#line 285 "../src/PulseAudioManager.vala"
				_tmp44_ = g_strdup (_tmp43_);
#line 285 "../src/PulseAudioManager.vala"
				_g_free0 (_tmp39_->description);
#line 285 "../src/PulseAudioManager.vala"
				_tmp39_->description = _tmp44_;
#line 286 "../src/PulseAudioManager.vala"
				_tmp45_ = new_port;
#line 286 "../src/PulseAudioManager.vala"
				_tmp46_ = (*i).ports;
#line 286 "../src/PulseAudioManager.vala"
				_tmp46__length1 = (*i).n_ports;
#line 286 "../src/PulseAudioManager.vala"
				_tmp47_ = idx;
#line 286 "../src/PulseAudioManager.vala"
				_tmp48_ = _tmp46_[_tmp47_];
#line 286 "../src/PulseAudioManager.vala"
				_tmp49_ = (*_tmp48_).priority;
#line 286 "../src/PulseAudioManager.vala"
				_tmp45_->priority = _tmp49_;
#line 287 "../src/PulseAudioManager.vala"
				_tmp50_ = _data2_->device;
#line 287 "../src/PulseAudioManager.vala"
				_tmp51_ = sound_device_get_ports (_tmp50_);
#line 287 "../src/PulseAudioManager.vala"
				_tmp52_ = _tmp51_;
#line 287 "../src/PulseAudioManager.vala"
				_tmp53_ = new_port;
#line 287 "../src/PulseAudioManager.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp52_, _tmp53_);
#line 289 "../src/PulseAudioManager.vala"
				_tmp54_ = (*i).ports;
#line 289 "../src/PulseAudioManager.vala"
				_tmp54__length1 = (*i).n_ports;
#line 289 "../src/PulseAudioManager.vala"
				_tmp55_ = idx;
#line 289 "../src/PulseAudioManager.vala"
				_tmp56_ = _tmp54_[_tmp55_];
#line 289 "../src/PulseAudioManager.vala"
				_tmp57_ = (*i).active_port;
#line 289 "../src/PulseAudioManager.vala"
				if (_tmp56_ == _tmp57_) {
#line 1898 "PulseAudioManager.c"
					SoundDevice* _tmp58_;
					SoundDevicePort* _tmp59_;
#line 290 "../src/PulseAudioManager.vala"
					_tmp58_ = _data2_->device;
#line 290 "../src/PulseAudioManager.vala"
					_tmp59_ = new_port;
#line 290 "../src/PulseAudioManager.vala"
					sound_device_set_default_port (_tmp58_, _tmp59_);
#line 1907 "PulseAudioManager.c"
				}
#line 282 "../src/PulseAudioManager.vala"
				_sound_device_port_unref0 (new_port);
#line 1911 "PulseAudioManager.c"
			}
		}
	}
#line 294 "../src/PulseAudioManager.vala"
	_tmp60_ = _data2_->device;
#line 294 "../src/PulseAudioManager.vala"
	_tmp61_ = _tmp60_->volume_operations;
#line 294 "../src/PulseAudioManager.vala"
	_tmp62_ = gee_collection_get_is_empty ((GeeCollection*) _tmp61_);
#line 294 "../src/PulseAudioManager.vala"
	_tmp63_ = _tmp62_;
#line 294 "../src/PulseAudioManager.vala"
	if (_tmp63_) {
#line 1925 "PulseAudioManager.c"
		SoundDevice* _tmp64_;
#line 295 "../src/PulseAudioManager.vala"
		_tmp64_ = _data2_->device;
#line 295 "../src/PulseAudioManager.vala"
		sound_device_set_volume (_tmp64_, sound_pulse_audio_manager_volume_to_double (pa_cvolume_max (&(*i).volume)));
#line 1931 "PulseAudioManager.c"
	}
#line 298 "../src/PulseAudioManager.vala"
	_tmp65_ = (*i).proplist;
#line 298 "../src/PulseAudioManager.vala"
	_tmp66_ = pa_proplist_gets (_tmp65_, PA_PROP_DEVICE_FORM_FACTOR);
#line 298 "../src/PulseAudioManager.vala"
	_tmp67_ = g_strdup (_tmp66_);
#line 298 "../src/PulseAudioManager.vala"
	form_factor = _tmp67_;
#line 299 "../src/PulseAudioManager.vala"
	_tmp68_ = form_factor;
#line 299 "../src/PulseAudioManager.vala"
	if (_tmp68_ != NULL) {
#line 1945 "PulseAudioManager.c"
		SoundDevice* _tmp69_;
		const gchar* _tmp70_;
#line 300 "../src/PulseAudioManager.vala"
		_tmp69_ = _data2_->device;
#line 300 "../src/PulseAudioManager.vala"
		_tmp70_ = form_factor;
#line 300 "../src/PulseAudioManager.vala"
		sound_device_set_form_factor (_tmp69_, _tmp70_);
#line 1954 "PulseAudioManager.c"
	}
#line 303 "../src/PulseAudioManager.vala"
	_tmp71_ = _data2_->device;
#line 303 "../src/PulseAudioManager.vala"
	_tmp72_ = (*i).name;
#line 303 "../src/PulseAudioManager.vala"
	_tmp73_ = self->priv->default_source_name;
#line 303 "../src/PulseAudioManager.vala"
	sound_device_set_is_default (_tmp71_, g_strcmp0 (_tmp72_, _tmp73_) == 0);
#line 304 "../src/PulseAudioManager.vala"
	_tmp74_ = _data2_->device;
#line 304 "../src/PulseAudioManager.vala"
	_tmp75_ = sound_device_get_is_default (_tmp74_);
#line 304 "../src/PulseAudioManager.vala"
	_tmp76_ = _tmp75_;
#line 304 "../src/PulseAudioManager.vala"
	if (_tmp76_) {
#line 1972 "PulseAudioManager.c"
		SoundDevice* _tmp77_;
#line 305 "../src/PulseAudioManager.vala"
		_tmp77_ = _data2_->device;
#line 305 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_input (self, _tmp77_);
#line 1978 "PulseAudioManager.c"
	}
#line 309 "../src/PulseAudioManager.vala"
	_tmp78_ = is_new;
#line 309 "../src/PulseAudioManager.vala"
	if (_tmp78_) {
#line 1984 "PulseAudioManager.c"
		GeeHashMap* _tmp79_;
		guint32 _tmp80_;
		SoundDevice* _tmp81_;
		SoundDevice* _tmp82_;
#line 310 "../src/PulseAudioManager.vala"
		_tmp79_ = self->priv->input_devices;
#line 310 "../src/PulseAudioManager.vala"
		_tmp80_ = (*i).index;
#line 310 "../src/PulseAudioManager.vala"
		_tmp81_ = _data2_->device;
#line 310 "../src/PulseAudioManager.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp79_, (gpointer) ((guintptr) _tmp80_), _tmp81_);
#line 311 "../src/PulseAudioManager.vala"
		_tmp82_ = _data2_->device;
#line 311 "../src/PulseAudioManager.vala"
		g_signal_emit (self, sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL], 0, _tmp82_);
#line 2001 "PulseAudioManager.c"
	}
#line 248 "../src/PulseAudioManager.vala"
	_g_free0 (form_factor);
#line 248 "../src/PulseAudioManager.vala"
	block2_data_unref (_data2_);
#line 248 "../src/PulseAudioManager.vala"
	_data2_ = NULL;
#line 2009 "PulseAudioManager.c"
}


static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 315 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 315 "../src/PulseAudioManager.vala"
	return _data3_;
#line 2020 "PulseAudioManager.c"
}


static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 315 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 2031 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 315 "../src/PulseAudioManager.vala"
		self = _data3_->self;
#line 315 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_data3_->device);
#line 315 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 315 "../src/PulseAudioManager.vala"
		g_slice_free (Block3Data, _data3_);
#line 2041 "PulseAudioManager.c"
	}
}


static gboolean
__lambda5_ (Block3Data* _data3_,
            pa_operation* operation)
{
	SoundPulseAudioManager* self;
	gboolean result = FALSE;
#line 334 "../src/PulseAudioManager.vala"
	self = _data3_->self;
#line 334 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (operation != NULL, FALSE);
#line 335 "../src/PulseAudioManager.vala"
	if (pa_operation_get_state (operation) != PA_OPERATION_RUNNING) {
#line 2058 "PulseAudioManager.c"
		SoundDevice* _tmp0_;
		GeeLinkedList* _tmp1_;
#line 336 "../src/PulseAudioManager.vala"
		_tmp0_ = _data3_->device;
#line 336 "../src/PulseAudioManager.vala"
		_tmp1_ = _tmp0_->volume_operations;
#line 336 "../src/PulseAudioManager.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, operation);
#line 2067 "PulseAudioManager.c"
	}
#line 339 "../src/PulseAudioManager.vala"
	result = G_SOURCE_CONTINUE;
#line 339 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (operation);
#line 339 "../src/PulseAudioManager.vala"
	return result;
#line 2075 "PulseAudioManager.c"
}


static gboolean
___lambda5__gee_forall_func (gpointer g,
                             gpointer self)
{
	gboolean result;
	result = __lambda5_ (self, (pa_operation*) g);
#line 334 "../src/PulseAudioManager.vala"
	return result;
#line 2087 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_sink_info* i,
                                              gint eol)
{
	Block3Data* _data3_;
	gboolean is_new = FALSE;
	GeeHashMap* _tmp0_;
	guint32 _tmp1_;
	gboolean _tmp2_;
	SoundDevice* _tmp8_;
	SoundDevice* _tmp9_;
	const gchar* _tmp10_;
	SoundDevice* _tmp11_;
	const gchar* _tmp12_;
	SoundDevice* _tmp13_;
	gint _tmp14_;
	SoundDevice* _tmp15_;
	pa_cvolume _tmp16_;
	SoundDevice* _tmp17_;
	pa_channel_map _tmp18_;
	SoundDevice* _tmp19_;
	pa_channel_map _tmp20_;
	SoundDevice* _tmp21_;
	GeeLinkedList* _tmp22_;
	SoundDevice* _tmp23_;
	GeeArrayList* _tmp24_;
	GeeArrayList* _tmp25_;
	SoundDevice* _tmp26_;
	SoundDevice* _tmp59_;
	GeeLinkedList* _tmp60_;
	gboolean _tmp61_;
	gboolean _tmp62_;
	gchar* form_factor = NULL;
	pa_proplist* _tmp64_;
	const gchar* _tmp65_;
	gchar* _tmp66_;
	const gchar* _tmp67_;
	SoundDevice* _tmp70_;
	const gchar* _tmp71_;
	const gchar* _tmp72_;
	SoundDevice* _tmp73_;
	gboolean _tmp74_;
	gboolean _tmp75_;
	gboolean _tmp77_;
#line 315 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 315 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 315 "../src/PulseAudioManager.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 315 "../src/PulseAudioManager.vala"
	_data3_->_ref_count_ = 1;
#line 315 "../src/PulseAudioManager.vala"
	_data3_->self = g_object_ref (self);
#line 316 "../src/PulseAudioManager.vala"
	if (i == NULL) {
#line 317 "../src/PulseAudioManager.vala"
		block3_data_unref (_data3_);
#line 317 "../src/PulseAudioManager.vala"
		_data3_ = NULL;
#line 317 "../src/PulseAudioManager.vala"
		return;
#line 2155 "PulseAudioManager.c"
	}
#line 319 "../src/PulseAudioManager.vala"
	_data3_->device = NULL;
#line 320 "../src/PulseAudioManager.vala"
	_tmp0_ = self->priv->output_devices;
#line 320 "../src/PulseAudioManager.vala"
	_tmp1_ = (*i).index;
#line 320 "../src/PulseAudioManager.vala"
	is_new = !gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, (gpointer) ((guintptr) _tmp1_));
#line 321 "../src/PulseAudioManager.vala"
	_tmp2_ = is_new;
#line 321 "../src/PulseAudioManager.vala"
	if (_tmp2_) {
#line 2169 "PulseAudioManager.c"
		guint32 _tmp3_;
		SoundDevice* _tmp4_;
#line 322 "../src/PulseAudioManager.vala"
		_tmp3_ = (*i).index;
#line 322 "../src/PulseAudioManager.vala"
		_tmp4_ = sound_device_new (_tmp3_);
#line 322 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_data3_->device);
#line 322 "../src/PulseAudioManager.vala"
		_data3_->device = _tmp4_;
#line 2180 "PulseAudioManager.c"
	} else {
		GeeHashMap* _tmp5_;
		guint32 _tmp6_;
		gpointer _tmp7_;
#line 324 "../src/PulseAudioManager.vala"
		_tmp5_ = self->priv->output_devices;
#line 324 "../src/PulseAudioManager.vala"
		_tmp6_ = (*i).index;
#line 324 "../src/PulseAudioManager.vala"
		_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, (gpointer) ((guintptr) _tmp6_));
#line 324 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_data3_->device);
#line 324 "../src/PulseAudioManager.vala"
		_data3_->device = (SoundDevice*) _tmp7_;
#line 2195 "PulseAudioManager.c"
	}
#line 327 "../src/PulseAudioManager.vala"
	_tmp8_ = _data3_->device;
#line 327 "../src/PulseAudioManager.vala"
	sound_device_set_input (_tmp8_, FALSE);
#line 328 "../src/PulseAudioManager.vala"
	_tmp9_ = _data3_->device;
#line 328 "../src/PulseAudioManager.vala"
	_tmp10_ = (*i).name;
#line 328 "../src/PulseAudioManager.vala"
	sound_device_set_name (_tmp9_, _tmp10_);
#line 329 "../src/PulseAudioManager.vala"
	_tmp11_ = _data3_->device;
#line 329 "../src/PulseAudioManager.vala"
	_tmp12_ = (*i).description;
#line 329 "../src/PulseAudioManager.vala"
	sound_device_set_display_name (_tmp11_, _tmp12_);
#line 330 "../src/PulseAudioManager.vala"
	_tmp13_ = _data3_->device;
#line 330 "../src/PulseAudioManager.vala"
	_tmp14_ = (*i).mute;
#line 330 "../src/PulseAudioManager.vala"
	sound_device_set_is_muted (_tmp13_, _tmp14_ != 0);
#line 331 "../src/PulseAudioManager.vala"
	_tmp15_ = _data3_->device;
#line 331 "../src/PulseAudioManager.vala"
	_tmp16_ = (*i).volume;
#line 331 "../src/PulseAudioManager.vala"
	sound_device_set_cvolume (_tmp15_, &_tmp16_);
#line 332 "../src/PulseAudioManager.vala"
	_tmp17_ = _data3_->device;
#line 332 "../src/PulseAudioManager.vala"
	_tmp18_ = (*i).channel_map;
#line 332 "../src/PulseAudioManager.vala"
	sound_device_set_channel_map (_tmp17_, &_tmp18_);
#line 333 "../src/PulseAudioManager.vala"
	_tmp19_ = _data3_->device;
#line 333 "../src/PulseAudioManager.vala"
	_tmp20_ = (*i).channel_map;
#line 333 "../src/PulseAudioManager.vala"
	sound_device_set_balance (_tmp19_, pa_cvolume_get_balance (&(*i).volume, &_tmp20_));
#line 334 "../src/PulseAudioManager.vala"
	_tmp21_ = _data3_->device;
#line 334 "../src/PulseAudioManager.vala"
	_tmp22_ = _tmp21_->volume_operations;
#line 334 "../src/PulseAudioManager.vala"
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp22_, ___lambda5__gee_forall_func, _data3_);
#line 342 "../src/PulseAudioManager.vala"
	_tmp23_ = _data3_->device;
#line 342 "../src/PulseAudioManager.vala"
	_tmp24_ = sound_device_get_ports (_tmp23_);
#line 342 "../src/PulseAudioManager.vala"
	_tmp25_ = _tmp24_;
#line 342 "../src/PulseAudioManager.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp25_);
#line 343 "../src/PulseAudioManager.vala"
	_tmp26_ = _data3_->device;
#line 343 "../src/PulseAudioManager.vala"
	sound_device_set_default_port (_tmp26_, NULL);
#line 2255 "PulseAudioManager.c"
	{
		gint idx = 0;
#line 344 "../src/PulseAudioManager.vala"
		idx = 0;
#line 2260 "PulseAudioManager.c"
		{
			gboolean _tmp27_ = FALSE;
#line 344 "../src/PulseAudioManager.vala"
			_tmp27_ = TRUE;
#line 344 "../src/PulseAudioManager.vala"
			while (TRUE) {
#line 2267 "PulseAudioManager.c"
				gint _tmp29_;
				guint32 _tmp30_;
				SoundDevicePort* new_port = NULL;
				SoundDevicePort* _tmp31_;
				SoundDevicePort* _tmp32_;
				pa_sink_port_info** _tmp33_;
				gint _tmp33__length1;
				gint _tmp34_;
				pa_sink_port_info* _tmp35_;
				const gchar* _tmp36_;
				gchar* _tmp37_;
				SoundDevicePort* _tmp38_;
				pa_sink_port_info** _tmp39_;
				gint _tmp39__length1;
				gint _tmp40_;
				pa_sink_port_info* _tmp41_;
				const gchar* _tmp42_;
				gchar* _tmp43_;
				SoundDevicePort* _tmp44_;
				pa_sink_port_info** _tmp45_;
				gint _tmp45__length1;
				gint _tmp46_;
				pa_sink_port_info* _tmp47_;
				guint32 _tmp48_;
				SoundDevice* _tmp49_;
				GeeArrayList* _tmp50_;
				GeeArrayList* _tmp51_;
				SoundDevicePort* _tmp52_;
				pa_sink_port_info** _tmp53_;
				gint _tmp53__length1;
				gint _tmp54_;
				pa_sink_port_info* _tmp55_;
				pa_sink_port_info* _tmp56_;
#line 344 "../src/PulseAudioManager.vala"
				if (!_tmp27_) {
#line 2303 "PulseAudioManager.c"
					gint _tmp28_;
#line 344 "../src/PulseAudioManager.vala"
					_tmp28_ = idx;
#line 344 "../src/PulseAudioManager.vala"
					idx = _tmp28_ + 1;
#line 2309 "PulseAudioManager.c"
				}
#line 344 "../src/PulseAudioManager.vala"
				_tmp27_ = FALSE;
#line 344 "../src/PulseAudioManager.vala"
				_tmp29_ = idx;
#line 344 "../src/PulseAudioManager.vala"
				_tmp30_ = (*i).n_ports;
#line 344 "../src/PulseAudioManager.vala"
				if (!(((guint32) _tmp29_) < _tmp30_)) {
#line 344 "../src/PulseAudioManager.vala"
					break;
#line 2321 "PulseAudioManager.c"
				}
#line 345 "../src/PulseAudioManager.vala"
				_tmp31_ = sound_device_port_new ();
#line 345 "../src/PulseAudioManager.vala"
				new_port = _tmp31_;
#line 346 "../src/PulseAudioManager.vala"
				_tmp32_ = new_port;
#line 346 "../src/PulseAudioManager.vala"
				_tmp33_ = (*i).ports;
#line 346 "../src/PulseAudioManager.vala"
				_tmp33__length1 = (*i).n_ports;
#line 346 "../src/PulseAudioManager.vala"
				_tmp34_ = idx;
#line 346 "../src/PulseAudioManager.vala"
				_tmp35_ = _tmp33_[_tmp34_];
#line 346 "../src/PulseAudioManager.vala"
				_tmp36_ = (*_tmp35_).name;
#line 346 "../src/PulseAudioManager.vala"
				_tmp37_ = g_strdup (_tmp36_);
#line 346 "../src/PulseAudioManager.vala"
				_g_free0 (_tmp32_->name);
#line 346 "../src/PulseAudioManager.vala"
				_tmp32_->name = _tmp37_;
#line 347 "../src/PulseAudioManager.vala"
				_tmp38_ = new_port;
#line 347 "../src/PulseAudioManager.vala"
				_tmp39_ = (*i).ports;
#line 347 "../src/PulseAudioManager.vala"
				_tmp39__length1 = (*i).n_ports;
#line 347 "../src/PulseAudioManager.vala"
				_tmp40_ = idx;
#line 347 "../src/PulseAudioManager.vala"
				_tmp41_ = _tmp39_[_tmp40_];
#line 347 "../src/PulseAudioManager.vala"
				_tmp42_ = (*_tmp41_).description;
#line 347 "../src/PulseAudioManager.vala"
				_tmp43_ = g_strdup (_tmp42_);
#line 347 "../src/PulseAudioManager.vala"
				_g_free0 (_tmp38_->description);
#line 347 "../src/PulseAudioManager.vala"
				_tmp38_->description = _tmp43_;
#line 348 "../src/PulseAudioManager.vala"
				_tmp44_ = new_port;
#line 348 "../src/PulseAudioManager.vala"
				_tmp45_ = (*i).ports;
#line 348 "../src/PulseAudioManager.vala"
				_tmp45__length1 = (*i).n_ports;
#line 348 "../src/PulseAudioManager.vala"
				_tmp46_ = idx;
#line 348 "../src/PulseAudioManager.vala"
				_tmp47_ = _tmp45_[_tmp46_];
#line 348 "../src/PulseAudioManager.vala"
				_tmp48_ = (*_tmp47_).priority;
#line 348 "../src/PulseAudioManager.vala"
				_tmp44_->priority = _tmp48_;
#line 349 "../src/PulseAudioManager.vala"
				_tmp49_ = _data3_->device;
#line 349 "../src/PulseAudioManager.vala"
				_tmp50_ = sound_device_get_ports (_tmp49_);
#line 349 "../src/PulseAudioManager.vala"
				_tmp51_ = _tmp50_;
#line 349 "../src/PulseAudioManager.vala"
				_tmp52_ = new_port;
#line 349 "../src/PulseAudioManager.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp51_, _tmp52_);
#line 351 "../src/PulseAudioManager.vala"
				_tmp53_ = (*i).ports;
#line 351 "../src/PulseAudioManager.vala"
				_tmp53__length1 = (*i).n_ports;
#line 351 "../src/PulseAudioManager.vala"
				_tmp54_ = idx;
#line 351 "../src/PulseAudioManager.vala"
				_tmp55_ = _tmp53_[_tmp54_];
#line 351 "../src/PulseAudioManager.vala"
				_tmp56_ = (*i).active_port;
#line 351 "../src/PulseAudioManager.vala"
				if (_tmp55_ == _tmp56_) {
#line 2399 "PulseAudioManager.c"
					SoundDevice* _tmp57_;
					SoundDevicePort* _tmp58_;
#line 352 "../src/PulseAudioManager.vala"
					_tmp57_ = _data3_->device;
#line 352 "../src/PulseAudioManager.vala"
					_tmp58_ = new_port;
#line 352 "../src/PulseAudioManager.vala"
					sound_device_set_default_port (_tmp57_, _tmp58_);
#line 2408 "PulseAudioManager.c"
				}
#line 344 "../src/PulseAudioManager.vala"
				_sound_device_port_unref0 (new_port);
#line 2412 "PulseAudioManager.c"
			}
		}
	}
#line 356 "../src/PulseAudioManager.vala"
	_tmp59_ = _data3_->device;
#line 356 "../src/PulseAudioManager.vala"
	_tmp60_ = _tmp59_->volume_operations;
#line 356 "../src/PulseAudioManager.vala"
	_tmp61_ = gee_collection_get_is_empty ((GeeCollection*) _tmp60_);
#line 356 "../src/PulseAudioManager.vala"
	_tmp62_ = _tmp61_;
#line 356 "../src/PulseAudioManager.vala"
	if (_tmp62_) {
#line 2426 "PulseAudioManager.c"
		SoundDevice* _tmp63_;
#line 357 "../src/PulseAudioManager.vala"
		_tmp63_ = _data3_->device;
#line 357 "../src/PulseAudioManager.vala"
		sound_device_set_volume (_tmp63_, sound_pulse_audio_manager_volume_to_double (pa_cvolume_max (&(*i).volume)));
#line 2432 "PulseAudioManager.c"
	}
#line 360 "../src/PulseAudioManager.vala"
	_tmp64_ = (*i).proplist;
#line 360 "../src/PulseAudioManager.vala"
	_tmp65_ = pa_proplist_gets (_tmp64_, PA_PROP_DEVICE_FORM_FACTOR);
#line 360 "../src/PulseAudioManager.vala"
	_tmp66_ = g_strdup (_tmp65_);
#line 360 "../src/PulseAudioManager.vala"
	form_factor = _tmp66_;
#line 361 "../src/PulseAudioManager.vala"
	_tmp67_ = form_factor;
#line 361 "../src/PulseAudioManager.vala"
	if (_tmp67_ != NULL) {
#line 2446 "PulseAudioManager.c"
		SoundDevice* _tmp68_;
		const gchar* _tmp69_;
#line 362 "../src/PulseAudioManager.vala"
		_tmp68_ = _data3_->device;
#line 362 "../src/PulseAudioManager.vala"
		_tmp69_ = form_factor;
#line 362 "../src/PulseAudioManager.vala"
		sound_device_set_form_factor (_tmp68_, _tmp69_);
#line 2455 "PulseAudioManager.c"
	}
#line 365 "../src/PulseAudioManager.vala"
	_tmp70_ = _data3_->device;
#line 365 "../src/PulseAudioManager.vala"
	_tmp71_ = (*i).name;
#line 365 "../src/PulseAudioManager.vala"
	_tmp72_ = self->priv->default_sink_name;
#line 365 "../src/PulseAudioManager.vala"
	sound_device_set_is_default (_tmp70_, g_strcmp0 (_tmp71_, _tmp72_) == 0);
#line 366 "../src/PulseAudioManager.vala"
	_tmp73_ = _data3_->device;
#line 366 "../src/PulseAudioManager.vala"
	_tmp74_ = sound_device_get_is_default (_tmp73_);
#line 366 "../src/PulseAudioManager.vala"
	_tmp75_ = _tmp74_;
#line 366 "../src/PulseAudioManager.vala"
	if (_tmp75_) {
#line 2473 "PulseAudioManager.c"
		SoundDevice* _tmp76_;
#line 367 "../src/PulseAudioManager.vala"
		_tmp76_ = _data3_->device;
#line 367 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_output (self, _tmp76_);
#line 2479 "PulseAudioManager.c"
	}
#line 371 "../src/PulseAudioManager.vala"
	_tmp77_ = is_new;
#line 371 "../src/PulseAudioManager.vala"
	if (_tmp77_) {
#line 2485 "PulseAudioManager.c"
		GeeHashMap* _tmp78_;
		guint32 _tmp79_;
		SoundDevice* _tmp80_;
		SoundDevice* _tmp81_;
#line 372 "../src/PulseAudioManager.vala"
		_tmp78_ = self->priv->output_devices;
#line 372 "../src/PulseAudioManager.vala"
		_tmp79_ = (*i).index;
#line 372 "../src/PulseAudioManager.vala"
		_tmp80_ = _data3_->device;
#line 372 "../src/PulseAudioManager.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp78_, (gpointer) ((guintptr) _tmp79_), _tmp80_);
#line 373 "../src/PulseAudioManager.vala"
		_tmp81_ = _data3_->device;
#line 373 "../src/PulseAudioManager.vala"
		g_signal_emit (self, sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL], 0, _tmp81_);
#line 2502 "PulseAudioManager.c"
	}
#line 315 "../src/PulseAudioManager.vala"
	_g_free0 (form_factor);
#line 315 "../src/PulseAudioManager.vala"
	block3_data_unref (_data3_);
#line 315 "../src/PulseAudioManager.vala"
	_data3_ = NULL;
#line 2510 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self,
                                                pa_context* c,
                                                pa_server_info* i)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	pa_context* _tmp4_;
	pa_operation* _tmp5_;
	pa_operation* _tmp6_;
	pa_context* _tmp7_;
	pa_operation* _tmp8_;
	pa_operation* _tmp9_;
#line 377 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 377 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 378 "../src/PulseAudioManager.vala"
	if (i == NULL) {
#line 379 "../src/PulseAudioManager.vala"
		return;
#line 2537 "PulseAudioManager.c"
	}
#line 381 "../src/PulseAudioManager.vala"
	_tmp0_ = (*i).default_source_name;
#line 381 "../src/PulseAudioManager.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 381 "../src/PulseAudioManager.vala"
	_g_free0 (self->priv->default_source_name);
#line 381 "../src/PulseAudioManager.vala"
	self->priv->default_source_name = _tmp1_;
#line 382 "../src/PulseAudioManager.vala"
	_tmp2_ = (*i).default_sink_name;
#line 382 "../src/PulseAudioManager.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 382 "../src/PulseAudioManager.vala"
	_g_free0 (self->priv->default_sink_name);
#line 382 "../src/PulseAudioManager.vala"
	self->priv->default_sink_name = _tmp3_;
#line 383 "../src/PulseAudioManager.vala"
	_tmp4_ = self->priv->_context;
#line 383 "../src/PulseAudioManager.vala"
	_tmp5_ = pa_context_get_sink_info_list (_tmp4_, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
#line 383 "../src/PulseAudioManager.vala"
	_tmp6_ = _tmp5_;
#line 383 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp6_);
#line 384 "../src/PulseAudioManager.vala"
	_tmp7_ = self->priv->_context;
#line 384 "../src/PulseAudioManager.vala"
	_tmp8_ = pa_context_get_source_info_list (_tmp7_, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
#line 384 "../src/PulseAudioManager.vala"
	_tmp9_ = _tmp8_;
#line 384 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp9_);
#line 2571 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self,
                                                                 pa_context* c,
                                                                 pa_ext_stream_restore_info* info,
                                                                 gint eol)
{
	gboolean _tmp0_ = FALSE;
	pa_ext_stream_restore_info new_info = {0};
	const gchar* _tmp2_;
	gchar* _tmp3_;
	pa_channel_map _tmp4_;
	pa_cvolume _tmp5_;
	gint _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	pa_ext_stream_restore_info _tmp9_;
	pa_ext_stream_restore_info* _tmp10_;
	pa_ext_stream_restore_info* _tmp11_;
	gint _tmp11__length1;
	pa_operation* _tmp12_;
	pa_operation* _tmp13_;
#line 391 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 391 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 392 "../src/PulseAudioManager.vala"
	if (eol != 0) {
#line 392 "../src/PulseAudioManager.vala"
		_tmp0_ = TRUE;
#line 2604 "PulseAudioManager.c"
	} else {
		const gchar* _tmp1_;
#line 392 "../src/PulseAudioManager.vala"
		_tmp1_ = (*info).name;
#line 392 "../src/PulseAudioManager.vala"
		_tmp0_ = !g_str_has_prefix (_tmp1_, "sink-input-by");
#line 2611 "PulseAudioManager.c"
	}
#line 392 "../src/PulseAudioManager.vala"
	if (_tmp0_) {
#line 393 "../src/PulseAudioManager.vala"
		return;
#line 2617 "PulseAudioManager.c"
	}
#line 397 "../src/PulseAudioManager.vala"
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
#line 398 "../src/PulseAudioManager.vala"
	_tmp2_ = (*info).name;
#line 398 "../src/PulseAudioManager.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 398 "../src/PulseAudioManager.vala"
	_g_free0 (new_info.name);
#line 398 "../src/PulseAudioManager.vala"
	new_info.name = _tmp3_;
#line 399 "../src/PulseAudioManager.vala"
	_tmp4_ = (*info).channel_map;
#line 399 "../src/PulseAudioManager.vala"
	new_info.channel_map = _tmp4_;
#line 400 "../src/PulseAudioManager.vala"
	_tmp5_ = (*info).volume;
#line 400 "../src/PulseAudioManager.vala"
	new_info.volume = _tmp5_;
#line 401 "../src/PulseAudioManager.vala"
	_tmp6_ = (*info).mute;
#line 401 "../src/PulseAudioManager.vala"
	new_info.mute = _tmp6_;
#line 402 "../src/PulseAudioManager.vala"
	_tmp7_ = self->priv->default_sink_name;
#line 402 "../src/PulseAudioManager.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 402 "../src/PulseAudioManager.vala"
	_g_free0 (new_info.device);
#line 402 "../src/PulseAudioManager.vala"
	new_info.device = _tmp8_;
#line 403 "../src/PulseAudioManager.vala"
	_tmp9_ = new_info;
#line 403 "../src/PulseAudioManager.vala"
	_tmp10_ = g_new0 (pa_ext_stream_restore_info, 1);
#line 403 "../src/PulseAudioManager.vala"
	_tmp10_[0] = _tmp9_;
#line 403 "../src/PulseAudioManager.vala"
	_tmp11_ = _tmp10_;
#line 403 "../src/PulseAudioManager.vala"
	_tmp11__length1 = 1;
#line 403 "../src/PulseAudioManager.vala"
	_tmp12_ = pa_ext_stream_restore_write (c, PA_UPDATE_REPLACE, _tmp11_, 1, 1, NULL, NULL);
#line 403 "../src/PulseAudioManager.vala"
	_tmp13_ = _tmp12_;
#line 403 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp13_);
#line 403 "../src/PulseAudioManager.vala"
	_tmp11_ = (g_free (_tmp11_), NULL);
#line 391 "../src/PulseAudioManager.vala"
	 (&new_info);
#line 2669 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self,
                                                                   pa_context* c,
                                                                   pa_ext_stream_restore_info* info,
                                                                   gint eol)
{
	gboolean _tmp0_ = FALSE;
	pa_ext_stream_restore_info new_info = {0};
	const gchar* _tmp2_;
	gchar* _tmp3_;
	pa_channel_map _tmp4_;
	pa_cvolume _tmp5_;
	gint _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	pa_ext_stream_restore_info _tmp9_;
	pa_ext_stream_restore_info* _tmp10_;
	pa_ext_stream_restore_info* _tmp11_;
	gint _tmp11__length1;
	pa_operation* _tmp12_;
	pa_operation* _tmp13_;
#line 406 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 406 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 407 "../src/PulseAudioManager.vala"
	if (eol != 0) {
#line 407 "../src/PulseAudioManager.vala"
		_tmp0_ = TRUE;
#line 2702 "PulseAudioManager.c"
	} else {
		const gchar* _tmp1_;
#line 407 "../src/PulseAudioManager.vala"
		_tmp1_ = (*info).name;
#line 407 "../src/PulseAudioManager.vala"
		_tmp0_ = !g_str_has_prefix (_tmp1_, "source-output-by");
#line 2709 "PulseAudioManager.c"
	}
#line 407 "../src/PulseAudioManager.vala"
	if (_tmp0_) {
#line 408 "../src/PulseAudioManager.vala"
		return;
#line 2715 "PulseAudioManager.c"
	}
#line 412 "../src/PulseAudioManager.vala"
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
#line 413 "../src/PulseAudioManager.vala"
	_tmp2_ = (*info).name;
#line 413 "../src/PulseAudioManager.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 413 "../src/PulseAudioManager.vala"
	_g_free0 (new_info.name);
#line 413 "../src/PulseAudioManager.vala"
	new_info.name = _tmp3_;
#line 414 "../src/PulseAudioManager.vala"
	_tmp4_ = (*info).channel_map;
#line 414 "../src/PulseAudioManager.vala"
	new_info.channel_map = _tmp4_;
#line 415 "../src/PulseAudioManager.vala"
	_tmp5_ = (*info).volume;
#line 415 "../src/PulseAudioManager.vala"
	new_info.volume = _tmp5_;
#line 416 "../src/PulseAudioManager.vala"
	_tmp6_ = (*info).mute;
#line 416 "../src/PulseAudioManager.vala"
	new_info.mute = _tmp6_;
#line 417 "../src/PulseAudioManager.vala"
	_tmp7_ = self->priv->default_source_name;
#line 417 "../src/PulseAudioManager.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 417 "../src/PulseAudioManager.vala"
	_g_free0 (new_info.device);
#line 417 "../src/PulseAudioManager.vala"
	new_info.device = _tmp8_;
#line 418 "../src/PulseAudioManager.vala"
	_tmp9_ = new_info;
#line 418 "../src/PulseAudioManager.vala"
	_tmp10_ = g_new0 (pa_ext_stream_restore_info, 1);
#line 418 "../src/PulseAudioManager.vala"
	_tmp10_[0] = _tmp9_;
#line 418 "../src/PulseAudioManager.vala"
	_tmp11_ = _tmp10_;
#line 418 "../src/PulseAudioManager.vala"
	_tmp11__length1 = 1;
#line 418 "../src/PulseAudioManager.vala"
	_tmp12_ = pa_ext_stream_restore_write (c, PA_UPDATE_REPLACE, _tmp11_, 1, 1, NULL, NULL);
#line 418 "../src/PulseAudioManager.vala"
	_tmp13_ = _tmp12_;
#line 418 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp13_);
#line 418 "../src/PulseAudioManager.vala"
	_tmp11_ = (g_free (_tmp11_), NULL);
#line 406 "../src/PulseAudioManager.vala"
	 (&new_info);
#line 2767 "PulseAudioManager.c"
}


static gdouble
sound_pulse_audio_manager_volume_to_double (pa_volume_t vol)
{
	gdouble result = 0.0;
	gdouble tmp = 0.0;
#line 426 "../src/PulseAudioManager.vala"
	tmp = (gdouble) (vol - PA_VOLUME_MUTED);
#line 427 "../src/PulseAudioManager.vala"
	result = (100 * tmp) / ((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED));
#line 427 "../src/PulseAudioManager.vala"
	return result;
#line 2782 "PulseAudioManager.c"
}


static pa_volume_t
sound_pulse_audio_manager_double_to_volume (gdouble vol)
{
	pa_volume_t result = 0U;
	gdouble tmp = 0.0;
#line 431 "../src/PulseAudioManager.vala"
	tmp = (((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED)) * vol) / 100;
#line 432 "../src/PulseAudioManager.vala"
	result = ((pa_volume_t) tmp) + PA_VOLUME_MUTED;
#line 432 "../src/PulseAudioManager.vala"
	return result;
#line 2797 "PulseAudioManager.c"
}


pa_context*
sound_pulse_audio_manager_get_context (SoundPulseAudioManager* self)
{
	pa_context* result;
	pa_context* _tmp0_;
#line 41 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/PulseAudioManager.vala"
	_tmp0_ = self->priv->_context;
#line 41 "../src/PulseAudioManager.vala"
	result = _tmp0_;
#line 41 "../src/PulseAudioManager.vala"
	return result;
#line 2814 "PulseAudioManager.c"
}


static gpointer
_pa_context_ref0 (gpointer self)
{
#line 41 "../src/PulseAudioManager.vala"
	return self ? pa_context_ref (self) : NULL;
#line 2823 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_set_context (SoundPulseAudioManager* self,
                                       pa_context* value)
{
#line 41 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/PulseAudioManager.vala"
	if (sound_pulse_audio_manager_get_context (self) != value) {
#line 2835 "PulseAudioManager.c"
		pa_context* _tmp0_;
#line 41 "../src/PulseAudioManager.vala"
		_tmp0_ = _pa_context_ref0 (value);
#line 41 "../src/PulseAudioManager.vala"
		_pa_context_unref0 (self->priv->_context);
#line 41 "../src/PulseAudioManager.vala"
		self->priv->_context = _tmp0_;
#line 41 "../src/PulseAudioManager.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY]);
#line 2845 "PulseAudioManager.c"
	}
}


SoundDevice*
sound_pulse_audio_manager_get_default_output (SoundPulseAudioManager* self)
{
	SoundDevice* result;
	SoundDevice* _tmp0_;
#line 47 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/PulseAudioManager.vala"
	_tmp0_ = self->priv->_default_output;
#line 47 "../src/PulseAudioManager.vala"
	result = _tmp0_;
#line 47 "../src/PulseAudioManager.vala"
	return result;
#line 2863 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self,
                                              SoundDevice* value)
{
#line 47 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/PulseAudioManager.vala"
	if (sound_pulse_audio_manager_get_default_output (self) != value) {
#line 2875 "PulseAudioManager.c"
		SoundDevice* _tmp0_;
#line 47 "../src/PulseAudioManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 47 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self->priv->_default_output);
#line 47 "../src/PulseAudioManager.vala"
		self->priv->_default_output = _tmp0_;
#line 47 "../src/PulseAudioManager.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY]);
#line 2885 "PulseAudioManager.c"
	}
}


SoundDevice*
sound_pulse_audio_manager_get_default_input (SoundPulseAudioManager* self)
{
	SoundDevice* result;
	SoundDevice* _tmp0_;
#line 48 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/PulseAudioManager.vala"
	_tmp0_ = self->priv->_default_input;
#line 48 "../src/PulseAudioManager.vala"
	result = _tmp0_;
#line 48 "../src/PulseAudioManager.vala"
	return result;
#line 2903 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self,
                                             SoundDevice* value)
{
#line 48 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/PulseAudioManager.vala"
	if (sound_pulse_audio_manager_get_default_input (self) != value) {
#line 2915 "PulseAudioManager.c"
		SoundDevice* _tmp0_;
#line 48 "../src/PulseAudioManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 48 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self->priv->_default_input);
#line 48 "../src/PulseAudioManager.vala"
		self->priv->_default_input = _tmp0_;
#line 48 "../src/PulseAudioManager.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY]);
#line 2925 "PulseAudioManager.c"
	}
}


static GObject *
sound_pulse_audio_manager_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundPulseAudioManager * self;
	pa_glib_mainloop* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
#line 57 "../src/PulseAudioManager.vala"
	parent_class = G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class);
#line 57 "../src/PulseAudioManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 57 "../src/PulseAudioManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 58 "../src/PulseAudioManager.vala"
	_tmp0_ = pa_glib_mainloop_new (NULL);
#line 58 "../src/PulseAudioManager.vala"
	_pa_glib_mainloop_free0 (self->priv->loop);
#line 58 "../src/PulseAudioManager.vala"
	self->priv->loop = _tmp0_;
#line 59 "../src/PulseAudioManager.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 59 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->input_devices);
#line 59 "../src/PulseAudioManager.vala"
	self->priv->input_devices = _tmp1_;
#line 60 "../src/PulseAudioManager.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 60 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->output_devices);
#line 60 "../src/PulseAudioManager.vala"
	self->priv->output_devices = _tmp2_;
#line 61 "../src/PulseAudioManager.vala"
	_tmp3_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, G_TYPE_POINTER, (GBoxedCopyFunc) pa_operation_ref, (GDestroyNotify) pa_operation_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 61 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->volume_operations);
#line 61 "../src/PulseAudioManager.vala"
	self->priv->volume_operations = _tmp3_;
#line 57 "../src/PulseAudioManager.vala"
	return obj;
#line 2974 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_class_init (SoundPulseAudioManagerClass * klass)
{
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/PulseAudioManager.vala"
	g_type_class_adjust_private_offset (klass, &SoundPulseAudioManager_private_offset);
#line 29 "../src/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_pulse_audio_manager_get_property;
#line 29 "../src/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_pulse_audio_manager_set_property;
#line 29 "../src/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_pulse_audio_manager_constructor;
#line 29 "../src/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_pulse_audio_manager_finalize;
#line 29 "../src/PulseAudioManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY] = g_param_spec_pointer ("context", "context", "context", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/PulseAudioManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY] = g_param_spec_object ("default-output", "default-output", "default-output", SOUND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/PulseAudioManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY] = g_param_spec_object ("default-input", "default-input", "default-input", SOUND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL] = g_signal_new ("new-device", SOUND_TYPE_PULSE_AUDIO_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, SOUND_TYPE_DEVICE);
#line 3001 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_instance_init (SoundPulseAudioManager * self)
{
#line 29 "../src/PulseAudioManager.vala"
	self->priv = sound_pulse_audio_manager_get_instance_private (self);
#line 43 "../src/PulseAudioManager.vala"
	self->priv->is_ready = FALSE;
#line 44 "../src/PulseAudioManager.vala"
	self->priv->reconnect_timer_id = 0U;
#line 3014 "PulseAudioManager.c"
}


static void
sound_pulse_audio_manager_finalize (GObject * obj)
{
	SoundPulseAudioManager * self;
#line 29 "../src/PulseAudioManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 41 "../src/PulseAudioManager.vala"
	_pa_context_unref0 (self->priv->_context);
#line 42 "../src/PulseAudioManager.vala"
	_pa_glib_mainloop_free0 (self->priv->loop);
#line 45 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->input_devices);
#line 46 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->output_devices);
#line 47 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->_default_output);
#line 48 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->_default_input);
#line 49 "../src/PulseAudioManager.vala"
	_g_free0 (self->priv->default_source_name);
#line 50 "../src/PulseAudioManager.vala"
	_g_free0 (self->priv->default_sink_name);
#line 51 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->volume_operations);
#line 29 "../src/PulseAudioManager.vala"
	G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class)->finalize (obj);
#line 3044 "PulseAudioManager.c"
}


GType
sound_pulse_audio_manager_get_type (void)
{
	static volatile gsize sound_pulse_audio_manager_type_id__volatile = 0;
	if (g_once_init_enter (&sound_pulse_audio_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SoundPulseAudioManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_pulse_audio_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundPulseAudioManager), 0, (GInstanceInitFunc) sound_pulse_audio_manager_instance_init, NULL };
		GType sound_pulse_audio_manager_type_id;
		sound_pulse_audio_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundPulseAudioManager", &g_define_type_info, 0);
		SoundPulseAudioManager_private_offset = g_type_add_instance_private (sound_pulse_audio_manager_type_id, sizeof (SoundPulseAudioManagerPrivate));
		g_once_init_leave (&sound_pulse_audio_manager_type_id__volatile, sound_pulse_audio_manager_type_id);
	}
	return sound_pulse_audio_manager_type_id__volatile;
}


static void
_vala_sound_pulse_audio_manager_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 29 "../src/PulseAudioManager.vala"
	switch (property_id) {
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		g_value_set_pointer (value, sound_pulse_audio_manager_get_context (self));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		g_value_set_object (value, sound_pulse_audio_manager_get_default_output (self));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		g_value_set_object (value, sound_pulse_audio_manager_get_default_input (self));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 3091 "PulseAudioManager.c"
		default:
#line 29 "../src/PulseAudioManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 3097 "PulseAudioManager.c"
	}
}


static void
_vala_sound_pulse_audio_manager_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 29 "../src/PulseAudioManager.vala"
	switch (property_id) {
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_context (self, g_value_get_pointer (value));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_output (self, g_value_get_object (value));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_input (self, g_value_get_object (value));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 3130 "PulseAudioManager.c"
		default:
#line 29 "../src/PulseAudioManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 3136 "PulseAudioManager.c"
	}
}



